import { XButton } from "./XButton";
import { ensureEnum, brushToString, stringToBrush, ensureBool, initializePropertiesFromCss, NamePatcher, toSpinal, enumToString, getAllPropertyNames, fromSpinal } from "igniteui-webcomponents-core";
import { FontInfo } from "igniteui-webcomponents-core";
import { WebComponentRenderer, PortalManager } from "igniteui-webcomponents-core";
import { delegateCombine, delegateRemove } from "igniteui-webcomponents-core";
import { TypeRegistrar } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
import { CornerRadius } from "igniteui-webcomponents-core";
import { ButtonDisplayStyle_$type } from './ButtonDisplayStyle';
import { IgcButtonClickEventArgs } from './igc-button-click-event-args';
import { ControlDisplayDensity_$type } from "igniteui-webcomponents-core";
import { BaseControlTheme_$type } from "igniteui-webcomponents-core";
import { ElevationMode_$type } from "igniteui-webcomponents-core";
import { IgcHTMLElement } from "igniteui-webcomponents-core";
import { HorizontalAlignment_$type } from "igniteui-webcomponents-core";
import { VerticalAlignment_$type } from "igniteui-webcomponents-core";
import { IgcFocusEventArgs } from "igniteui-webcomponents-core";
export let IgcXButtonComponent = /*@__PURE__*/ (() => {
    class IgcXButtonComponent extends IgcHTMLElement {
        _onDisplayChanged() {
            this.style.display = this.display;
        }
        _onFlexDirectionChanged() {
            this.style.flexDirection = this.flexDirection;
        }
        _onFlexGrowChanged() {
            this.style.flexGrow = this.flexGrow;
        }
        _onAlignItemsChanged() {
            this.style.alignItems = this.alignItems;
        }
        constructor() {
            super();
            this._disconnected = false;
            this._settingAttributes = false;
            this._attached = false;
            this._queuedSetAttributes = [];
            this._updatingFromAttribute = false;
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            this._clicked = null;
            this._clicked_wrapped = null;
            this._gotFocus = null;
            this._gotFocus_wrapped = null;
            this._lostFocus = null;
            this._lostFocus_wrapped = null;
            if (this._styling) {
                NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
            this._portalManager = new PortalManager("buttonContent");
            this._renderer = new WebComponentRenderer(this, document, true, {}, this._portalManager);
            this._container = this._renderer.createElement("div");
            this._renderer.updateRoot(this._container);
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            //this._container.setStyleProperty("width", "100%");
            //this._container.setStyleProperty("height", "100%");
            var root;
            root = this._container;
            if (this._container.getNativeElement() != null) {
                root = this._container.getNativeElement();
            }
            this._wrapper = this._renderer;
            var button = this.i;
            this._button = button;
            button.provideContainer(this._renderer);
            this._onChildrenChanged();
            //Checkbox.notifySizeChanged();
            let mut = new MutationObserver((list) => {
                for (var mutation of list) {
                    if (mutation.type == 'childList') {
                        this._onChildrenChanged();
                    }
                }
            });
            mut.observe(this, {
                childList: true
            });
            //this._renderer.addSizeWatcher(() => {
            //    this._checkbox.notifySizeChanged();
            //});
        }
        _onChildrenChanged() {
            var children = [];
            for (var i = 0; i < this.childNodes.length; i++) {
                var child = this.childNodes[i];
                if (child !== this._container.getNativeElement()) {
                    children.push(child);
                }
            }
            this._portalManager.onChildrenChanged(children);
        }
        // supports angular themes or custom properties set in CSS
        updateStyle() {
            this._styling(this, this);
        }
        destroy() {
            this._button.destroy();
            this._wrapper.destroy();
        }
        createImplementation() {
            return new XButton();
        }
        disconnectedCallback() {
            this._disconnected = true;
            if (this.i) {
                this.i.onDetachedFromUI();
            }
        }
        connectedCallback() {
            if (this._disconnected) {
                this._disconnected = false;
                if (this.i) {
                    this.i.onAttachedToUI();
                }
                return;
            }
            this.classList.add("ig-x-button");
            this.classList.add("igc-x-button");
            this.appendChild(this._container.getNativeElement());
            this._attached = true;
            this.style.display = this.display;
            //this.style.height = this._height;
            //this.style.width = this._width;
            this._flushQueuedAttributes();
            // supports themes or custom properties set in CSS 
            this._styling(this, this);
            this.afterContentInit();
        }
        afterContentInit() {
            //this.i.notifySizeChanged();
        }
        /**
         * @hidden
         */
        get i() {
            return this._implementation;
        } /**
                                     * @hidden
                                     */
        static _createFromInternal(internal) {
            if (!internal) {
                return null;
            }
            if (!internal.$type) {
                return null;
            }
            let name = internal.$type.name;
            let externalName = "Igc" + name + "Component";
            if (!TypeRegistrar.isRegistered(externalName)) {
                return null;
            }
            return TypeRegistrar.create(externalName);
        }
        _enqueueSetAttribute(attrName, attrValue) {
            this._queuedSetAttributes.push({ attrName: attrName, attrValue: attrValue });
        }
        _flushQueuedAttributes() {
            this._settingAttributes = true;
            for (let i = 0; i < this._queuedSetAttributes.length; i++) {
                this.setAttribute(this._queuedSetAttributes[i].attrName, this._queuedSetAttributes[i].attrValue);
            }
            this._settingAttributes = false;
            this._queuedSetAttributes.length = 0;
        }
        _a(attrName, attrValue) {
            if (this._updatingFromAttribute) {
                return;
            }
            if (attrValue) {
                attrValue = attrValue.toString();
            }
            this._settingAttributes = true;
            attrName = toSpinal(attrName);
            if (this._attached) {
                this.setAttribute(attrName, attrValue);
            }
            else {
                this._enqueueSetAttribute(attrName, attrValue);
            }
            this._settingAttributes = false;
        }
        static get observedAttributes() {
            if (IgcXButtonComponent._observedAttributesIgcXButtonComponent == null) {
                let names = getAllPropertyNames(IgcXButtonComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcXButtonComponent._observedAttributesIgcXButtonComponent = names;
            }
            return IgcXButtonComponent._observedAttributesIgcXButtonComponent;
        }
        attributeChangedCallback(name, oldValue, newValue) {
            if (this._settingAttributes) {
                return;
            }
            let setName = fromSpinal(name);
            this._updatingFromAttribute = true;
            this[setName] = newValue;
            this._updatingFromAttribute = false;
        }
        static register() {
            if (!IgcXButtonComponent._isElementRegistered) {
                IgcXButtonComponent._isElementRegistered = true;
                RegisterElementHelper.registerElement(IgcXButtonComponent.htmlTagName, IgcXButtonComponent);
            }
        }
        /**
     * Gets or sets the min width to use for the button.
    */
        get minWidth() {
            return this.i.bu;
        }
        set minWidth(v) {
            this.i.bu = +v;
            this._a("minWidth", this.i.bu);
        }
        /**
         * Gets or sets the min height to use for the button.
        */
        get minHeight() {
            return this.i.bt;
        }
        set minHeight(v) {
            this.i.bt = +v;
            this._a("minHeight", this.i.bt);
        }
        /**
         * Gets or sets the display style to use for the button.
        */
        get displayType() {
            return this.i.e;
        }
        set displayType(v) {
            this.i.e = ensureEnum(ButtonDisplayStyle_$type, v);
            this._a("displayType", enumToString(ButtonDisplayStyle_$type, this.i.e));
        }
        /**
         * Gets or sets the display density to use for the button.
        */
        get density() {
            return this.i.r;
        }
        set density(v) {
            this.i.r = ensureEnum(ControlDisplayDensity_$type, v);
            this._a("density", enumToString(ControlDisplayDensity_$type, this.i.r));
        }
        /**
         * Gets or sets the base built in theme to use for the button.
        */
        get baseTheme() {
            return this.i.n;
        }
        set baseTheme(v) {
            this.i.n = ensureEnum(BaseControlTheme_$type, v);
            this._a("baseTheme", enumToString(BaseControlTheme_$type, this.i.n));
        }
        /**
         * Gets the actual display density to use for the label.
        */
        get actualDensity() {
            return this.i.q;
        }
        set actualDensity(v) {
            this.i.q = ensureEnum(ControlDisplayDensity_$type, v);
            this._a("actualDensity", enumToString(ControlDisplayDensity_$type, this.i.q));
        }
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get actualBorderColor() {
            return brushToString(this.i.ng);
        }
        set actualBorderColor(v) {
            this.i.ng = stringToBrush(v);
            this._a("actualBorderColor", brushToString(this.i.ng));
        }
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get actualUmbraShadowColor() {
            return brushToString(this.i.nr);
        }
        set actualUmbraShadowColor(v) {
            this.i.nr = stringToBrush(v);
            this._a("actualUmbraShadowColor", brushToString(this.i.nr));
        }
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get actualPenumbraShadowColor() {
            return brushToString(this.i.no);
        }
        set actualPenumbraShadowColor(v) {
            this.i.no = stringToBrush(v);
            this._a("actualPenumbraShadowColor", brushToString(this.i.no));
        }
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get actualAmbientShadowColor() {
            return brushToString(this.i.ne);
        }
        set actualAmbientShadowColor(v) {
            this.i.ne = stringToBrush(v);
            this._a("actualAmbientShadowColor", brushToString(this.i.ne));
        }
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get actualRestingElevation() {
            return this.i.ct;
        }
        set actualRestingElevation(v) {
            this.i.ct = +v;
            this._a("actualRestingElevation", this.i.ct);
        }
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get actualFocusElevation() {
            return this.i.cr;
        }
        set actualFocusElevation(v) {
            this.i.cr = +v;
            this._a("actualFocusElevation", this.i.cr);
        }
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get actualHoverElevation() {
            return this.i.cs;
        }
        set actualHoverElevation(v) {
            this.i.cs = +v;
            this._a("actualHoverElevation", this.i.cs);
        }
        /**
         * Gets or sets the color to use for the ripple when the button is pressed.
        */
        get actualRippleColor() {
            return brushToString(this.i.np);
        }
        set actualRippleColor(v) {
            this.i.np = stringToBrush(v);
            this._a("actualRippleColor", brushToString(this.i.np));
        }
        get actualCornerRadiusBottomRight() {
            return this.i.kr ? this.i.kr.b : NaN;
        }
        set actualCornerRadiusBottomRight(v) {
            this.ensureActualCornerRadius();
            this.i.kr.b = +v;
            this._a("actualCornerRadiusBottomRight", this.i.kr.b);
            this.i.kr = this.i.kr;
        }
        get actualCornerRadiusBottomLeft() {
            return this.i.kr ? this.i.kr.a : NaN;
        }
        set actualCornerRadiusBottomLeft(v) {
            this.ensureActualCornerRadius();
            this.i.kr.a = +v;
            this._a("actualCornerRadiusBottomLeft", this.i.kr.a);
            this.i.kr = this.i.kr;
        }
        get actualCornerRadiusTopLeft() {
            return this.i.kr ? this.i.kr.c : NaN;
        }
        set actualCornerRadiusTopLeft(v) {
            this.ensureActualCornerRadius();
            this.i.kr.c = +v;
            this._a("actualCornerRadiusTopLeft", this.i.kr.c);
            this.i.kr = this.i.kr;
        }
        get actualCornerRadiusTopRight() {
            return this.i.kr ? this.i.kr.d : NaN;
        }
        set actualCornerRadiusTopRight(v) {
            this.ensureActualCornerRadius();
            this.i.kr.d = +v;
            this._a("actualCornerRadiusTopRight", this.i.kr.d);
            this.i.kr = this.i.kr;
        }
        ensureActualCornerRadius() {
            if (this.i.kr) {
                return;
            }
            this.i.kr = new CornerRadius(2);
        }
        /**
         * Gets the color to use for the actual background.
        */
        get actualBackgroundColor() {
            return brushToString(this.i.nf);
        }
        set actualBackgroundColor(v) {
            this.i.nf = stringToBrush(v);
            this._a("actualBackgroundColor", brushToString(this.i.nf));
        }
        /**
         * Gets the actual color to use for the disabled background of the button.
        */
        get actualDisabledBackgroundColor() {
            return brushToString(this.i.nh);
        }
        set actualDisabledBackgroundColor(v) {
            this.i.nh = stringToBrush(v);
            this._a("actualDisabledBackgroundColor", brushToString(this.i.nh));
        }
        /**
         * Gets the actual color to use for the disabled border of the button.
        */
        get actualDisabledBorderColor() {
            return brushToString(this.i.ni);
        }
        set actualDisabledBorderColor(v) {
            this.i.ni = stringToBrush(v);
            this._a("actualDisabledBorderColor", brushToString(this.i.ni));
        }
        /**
         * Gets the actual color to use for the disabled text of the button.
        */
        get actualDisabledTextColor() {
            return brushToString(this.i.nj);
        }
        set actualDisabledTextColor(v) {
            this.i.nj = stringToBrush(v);
            this._a("actualDisabledTextColor", brushToString(this.i.nj));
        }
        /**
         * Gets the actual disabled elevation to use for the button.
        */
        get actualDisabledElevation() {
            return this.i.cq;
        }
        set actualDisabledElevation(v) {
            this.i.cq = +v;
            this._a("actualDisabledElevation", this.i.cq);
        }
        /**
         * Gets the actual disabled elevation to use for the button.
        */
        get actualElevationMode() {
            return this.i.u;
        }
        set actualElevationMode(v) {
            this.i.u = ensureEnum(ElevationMode_$type, v);
            this._a("actualElevationMode", enumToString(ElevationMode_$type, this.i.u));
        }
        /**
         * Gets the color to use for the actual background.
        */
        get actualTextColor() {
            return brushToString(this.i.nq);
        }
        set actualTextColor(v) {
            this.i.nq = stringToBrush(v);
            this._a("actualTextColor", brushToString(this.i.nq));
        }
        /**
         * Gets the color to use for the actual background.
        */
        get actualHoverTextColor() {
            return brushToString(this.i.nn);
        }
        set actualHoverTextColor(v) {
            this.i.nn = stringToBrush(v);
            this._a("actualHoverTextColor", brushToString(this.i.nn));
        }
        /**
         * Gets the color to use for the actual background.
        */
        get actualFocusBackgroundColor() {
            return brushToString(this.i.nk);
        }
        set actualFocusBackgroundColor(v) {
            this.i.nk = stringToBrush(v);
            this._a("actualFocusBackgroundColor", brushToString(this.i.nk));
        }
        /**
         * Gets the actual color to use for the focused text.
        */
        get actualFocusTextColor() {
            return brushToString(this.i.nl);
        }
        set actualFocusTextColor(v) {
            this.i.nl = stringToBrush(v);
            this._a("actualFocusTextColor", brushToString(this.i.nl));
        }
        /**
         * Gets the hover color to use for the actual background.
        */
        get actualHoverBackgroundColor() {
            return brushToString(this.i.nm);
        }
        set actualHoverBackgroundColor(v) {
            this.i.nm = stringToBrush(v);
            this._a("actualHoverBackgroundColor", brushToString(this.i.nm));
        }
        /**
         * Gets or sets the Width to use for the check mark when the checkbox is checked.
        */
        get actualBorderWidth() {
            return this.i.bf;
        }
        set actualBorderWidth(v) {
            this.i.bf = +v;
            this._a("actualBorderWidth", this.i.bf);
        }
        /**
         * Gets or sets the color to use for the background of the button when the  type is raised.
        */
        get raisedBackgroundColor() {
            return brushToString(this.i.qv);
        }
        set raisedBackgroundColor(v) {
            this.i.qv = stringToBrush(v);
            this._a("raisedBackgroundColor", brushToString(this.i.qv));
        }
        /**
         * Gets or sets the color to use for the disabled background of the button when the type is raised.
        */
        get raisedDisabledBackgroundColor() {
            return brushToString(this.i.qx);
        }
        set raisedDisabledBackgroundColor(v) {
            this.i.qx = stringToBrush(v);
            this._a("raisedDisabledBackgroundColor", brushToString(this.i.qx));
        }
        /**
         * Gets or sets the color to use for the disabled border of the button when the type is raised.
        */
        get raisedDisabledBorderColor() {
            return brushToString(this.i.qy);
        }
        set raisedDisabledBorderColor(v) {
            this.i.qy = stringToBrush(v);
            this._a("raisedDisabledBorderColor", brushToString(this.i.qy));
        }
        /**
         * Gets or sets the color to use for the disabled text of the button when the type is raised.
        */
        get raisedDisabledTextColor() {
            return brushToString(this.i.qz);
        }
        set raisedDisabledTextColor(v) {
            this.i.qz = stringToBrush(v);
            this._a("raisedDisabledTextColor", brushToString(this.i.qz));
        }
        /**
         * Gets or sets the disabled elevation to use for the button when the type is raised.
        */
        get raisedDisabledElevation() {
            return this.i.dy;
        }
        set raisedDisabledElevation(v) {
            this.i.dy = +v;
            this._a("raisedDisabledElevation", this.i.dy);
        }
        /**
         * Gets or sets the hover color to use for the background of the button when the  type is raised.
        */
        get raisedHoverBackgroundColor() {
            return brushToString(this.i.q2);
        }
        set raisedHoverBackgroundColor(v) {
            this.i.q2 = stringToBrush(v);
            this._a("raisedHoverBackgroundColor", brushToString(this.i.q2));
        }
        /**
         * Gets or sets the border color to use for the button when the type is raised.
        */
        get raisedBorderColor() {
            return brushToString(this.i.qw);
        }
        set raisedBorderColor(v) {
            this.i.qw = stringToBrush(v);
            this._a("raisedBorderColor", brushToString(this.i.qw));
        }
        /**
         * Gets or sets the elevation to use for the button when the type is raised.
        */
        get raisedRestingElevation() {
            return this.i.d1;
        }
        set raisedRestingElevation(v) {
            this.i.d1 = +v;
            this._a("raisedRestingElevation", this.i.d1);
        }
        /**
         * Gets or sets the hover elevation to use for the button when the type is raised.
        */
        get raisedHoverElevation() {
            return this.i.d0;
        }
        set raisedHoverElevation(v) {
            this.i.d0 = +v;
            this._a("raisedHoverElevation", this.i.d0);
        }
        /**
         * Gets or sets the focus elevation to use for the button when the type is raised.
        */
        get raisedFocusElevation() {
            return this.i.dz;
        }
        set raisedFocusElevation(v) {
            this.i.dz = +v;
            this._a("raisedFocusElevation", this.i.dz);
        }
        /**
         * Gets or sets the width to use for the button border when the type is raised.
        */
        get raisedBorderWidth() {
            return this.i.bw;
        }
        set raisedBorderWidth(v) {
            this.i.bw = +v;
            this._a("raisedBorderWidth", this.i.bw);
        }
        get raisedCornerRadiusBottomRight() {
            return this.i.k3 ? this.i.k3.b : NaN;
        }
        set raisedCornerRadiusBottomRight(v) {
            this.ensureRaisedCornerRadius();
            this.i.k3.b = +v;
            this._a("raisedCornerRadiusBottomRight", this.i.k3.b);
            this.i.k3 = this.i.k3;
        }
        get raisedCornerRadiusBottomLeft() {
            return this.i.k3 ? this.i.k3.a : NaN;
        }
        set raisedCornerRadiusBottomLeft(v) {
            this.ensureRaisedCornerRadius();
            this.i.k3.a = +v;
            this._a("raisedCornerRadiusBottomLeft", this.i.k3.a);
            this.i.k3 = this.i.k3;
        }
        get raisedCornerRadiusTopLeft() {
            return this.i.k3 ? this.i.k3.c : NaN;
        }
        set raisedCornerRadiusTopLeft(v) {
            this.ensureRaisedCornerRadius();
            this.i.k3.c = +v;
            this._a("raisedCornerRadiusTopLeft", this.i.k3.c);
            this.i.k3 = this.i.k3;
        }
        get raisedCornerRadiusTopRight() {
            return this.i.k3 ? this.i.k3.d : NaN;
        }
        set raisedCornerRadiusTopRight(v) {
            this.ensureRaisedCornerRadius();
            this.i.k3.d = +v;
            this._a("raisedCornerRadiusTopRight", this.i.k3.d);
            this.i.k3 = this.i.k3;
        }
        ensureRaisedCornerRadius() {
            if (this.i.k3) {
                return;
            }
            this.i.k3 = new CornerRadius(2);
        }
        /**
         * Gets or sets the color to use for the background when the button is pressed and the type is floating action button.
        */
        get raisedRippleColor() {
            return brushToString(this.i.q4);
        }
        set raisedRippleColor(v) {
            this.i.q4 = stringToBrush(v);
            this._a("raisedRippleColor", brushToString(this.i.q4));
        }
        /**
         * Gets or sets the color to use for the background of the button when the type is flat.
        */
        get flatBackgroundColor() {
            return brushToString(this.i.pu);
        }
        set flatBackgroundColor(v) {
            this.i.pu = stringToBrush(v);
            this._a("flatBackgroundColor", brushToString(this.i.pu));
        }
        /**
         * Gets or sets the color to use for the disabled background of the button when the type is flat.
        */
        get flatDisabledBackgroundColor() {
            return brushToString(this.i.pw);
        }
        set flatDisabledBackgroundColor(v) {
            this.i.pw = stringToBrush(v);
            this._a("flatDisabledBackgroundColor", brushToString(this.i.pw));
        }
        /**
         * Gets or sets the color to use for the disabled border of the button when the type is flat.
        */
        get flatDisabledBorderColor() {
            return brushToString(this.i.px);
        }
        set flatDisabledBorderColor(v) {
            this.i.px = stringToBrush(v);
            this._a("flatDisabledBorderColor", brushToString(this.i.px));
        }
        /**
         * Gets or sets the color to use for the disabled text of the button when the type is flat.
        */
        get flatDisabledTextColor() {
            return brushToString(this.i.py);
        }
        set flatDisabledTextColor(v) {
            this.i.py = stringToBrush(v);
            this._a("flatDisabledTextColor", brushToString(this.i.py));
        }
        /**
         * Gets or sets the disabled elevation to use for the button when the type is flat.
        */
        get flatDisabledElevation() {
            return this.i.dj;
        }
        set flatDisabledElevation(v) {
            this.i.dj = +v;
            this._a("flatDisabledElevation", this.i.dj);
        }
        /**
         * Gets or sets the hover color to use for the background of the button when the type is flat.
        */
        get flatHoverBackgroundColor() {
            return brushToString(this.i.p1);
        }
        set flatHoverBackgroundColor(v) {
            this.i.p1 = stringToBrush(v);
            this._a("flatHoverBackgroundColor", brushToString(this.i.p1));
        }
        /**
         * Gets or sets the border color to use for the button when the type is flat.
        */
        get flatBorderColor() {
            return brushToString(this.i.pv);
        }
        set flatBorderColor(v) {
            this.i.pv = stringToBrush(v);
            this._a("flatBorderColor", brushToString(this.i.pv));
        }
        /**
         * Gets or sets the elevation to use for the button when the type is flat.
        */
        get flatRestingElevation() {
            return this.i.dm;
        }
        set flatRestingElevation(v) {
            this.i.dm = +v;
            this._a("flatRestingElevation", this.i.dm);
        }
        /**
         * Gets or sets the hover elevation to use for the button when the type is flat.
        */
        get flatHoverElevation() {
            return this.i.dl;
        }
        set flatHoverElevation(v) {
            this.i.dl = +v;
            this._a("flatHoverElevation", this.i.dl);
        }
        /**
         * Gets or sets the focus elevation to use for the button when the type is flat.
        */
        get flatFocusElevation() {
            return this.i.dk;
        }
        set flatFocusElevation(v) {
            this.i.dk = +v;
            this._a("flatFocusElevation", this.i.dk);
        }
        /**
         * Gets or sets the color to use for the background when the button is pressed and the type is floating action button.
        */
        get flatRippleColor() {
            return brushToString(this.i.p3);
        }
        set flatRippleColor(v) {
            this.i.p3 = stringToBrush(v);
            this._a("flatRippleColor", brushToString(this.i.p3));
        }
        /**
         * Gets or sets the color to use for the text of the button when type is flat.
        */
        get flatTextColor() {
            return brushToString(this.i.p4);
        }
        set flatTextColor(v) {
            this.i.p4 = stringToBrush(v);
            this._a("flatTextColor", brushToString(this.i.p4));
        }
        /**
         * Gets or sets the color to use for the hovered text of the button when type is flat.
        */
        get flatHoverTextColor() {
            return brushToString(this.i.p2);
        }
        set flatHoverTextColor(v) {
            this.i.p2 = stringToBrush(v);
            this._a("flatHoverTextColor", brushToString(this.i.p2));
        }
        /**
         * Gets or sets the color to use for the backround the button when it is focused and flat.
        */
        get flatFocusBackgroundColor() {
            return brushToString(this.i.pz);
        }
        set flatFocusBackgroundColor(v) {
            this.i.pz = stringToBrush(v);
            this._a("flatFocusBackgroundColor", brushToString(this.i.pz));
        }
        /**
         * Gets or sets the color to use for the text the button when it is focused and flat.
        */
        get flatFocusTextColor() {
            return brushToString(this.i.p0);
        }
        set flatFocusTextColor(v) {
            this.i.p0 = stringToBrush(v);
            this._a("flatFocusTextColor", brushToString(this.i.p0));
        }
        /**
         * Gets or sets the width to use for the button border when the type is flat.
        */
        get flatBorderWidth() {
            return this.i.br;
        }
        set flatBorderWidth(v) {
            this.i.br = +v;
            this._a("flatBorderWidth", this.i.br);
        }
        get flatCornerRadiusBottomRight() {
            return this.i.k0 ? this.i.k0.b : NaN;
        }
        set flatCornerRadiusBottomRight(v) {
            this.ensureFlatCornerRadius();
            this.i.k0.b = +v;
            this._a("flatCornerRadiusBottomRight", this.i.k0.b);
            this.i.k0 = this.i.k0;
        }
        get flatCornerRadiusBottomLeft() {
            return this.i.k0 ? this.i.k0.a : NaN;
        }
        set flatCornerRadiusBottomLeft(v) {
            this.ensureFlatCornerRadius();
            this.i.k0.a = +v;
            this._a("flatCornerRadiusBottomLeft", this.i.k0.a);
            this.i.k0 = this.i.k0;
        }
        get flatCornerRadiusTopLeft() {
            return this.i.k0 ? this.i.k0.c : NaN;
        }
        set flatCornerRadiusTopLeft(v) {
            this.ensureFlatCornerRadius();
            this.i.k0.c = +v;
            this._a("flatCornerRadiusTopLeft", this.i.k0.c);
            this.i.k0 = this.i.k0;
        }
        get flatCornerRadiusTopRight() {
            return this.i.k0 ? this.i.k0.d : NaN;
        }
        set flatCornerRadiusTopRight(v) {
            this.ensureFlatCornerRadius();
            this.i.k0.d = +v;
            this._a("flatCornerRadiusTopRight", this.i.k0.d);
            this.i.k0 = this.i.k0;
        }
        ensureFlatCornerRadius() {
            if (this.i.k0) {
                return;
            }
            this.i.k0 = new CornerRadius(2);
        }
        /**
         * Gets or sets the color to use for the background when the button regardless of type.
        */
        get backgroundColor() {
            return brushToString(this.i.ns);
        }
        set backgroundColor(v) {
            this.i.ns = stringToBrush(v);
            this._a("backgroundColor", brushToString(this.i.ns));
        }
        /**
         * Gets or sets the color to use for the disabled background of the button when the type is disabled.
        */
        get disabledBackgroundColor() {
            return brushToString(this.i.pg);
        }
        set disabledBackgroundColor(v) {
            this.i.pg = stringToBrush(v);
            this._a("disabledBackgroundColor", brushToString(this.i.pg));
        }
        /**
         * Gets or sets the color to use for the disabled border of the button when the type is raised.
        */
        get disabledBorderColor() {
            return brushToString(this.i.ph);
        }
        set disabledBorderColor(v) {
            this.i.ph = stringToBrush(v);
            this._a("disabledBorderColor", brushToString(this.i.ph));
        }
        /**
         * Gets or sets the color to use for the disabled text of the button when the type is raised.
        */
        get disabledTextColor() {
            return brushToString(this.i.pi);
        }
        set disabledTextColor(v) {
            this.i.pi = stringToBrush(v);
            this._a("disabledTextColor", brushToString(this.i.pi));
        }
        /**
         * Gets or sets the disabled elevation to use for the button when the type is raised.
        */
        get disabledElevation() {
            return this.i.de;
        }
        set disabledElevation(v) {
            this.i.de = +v;
            this._a("disabledElevation", this.i.de);
        }
        /**
         * Gets or sets the disabled elevation to use for the button when the type is raised.
        */
        get elevationMode() {
            return this.i.w;
        }
        set elevationMode(v) {
            this.i.w = ensureEnum(ElevationMode_$type, v);
            this._a("elevationMode", enumToString(ElevationMode_$type, this.i.w));
        }
        /**
         * Gets or sets the hover color to use for the background of the button when the  type is hovered.
        */
        get hoverBackgroundColor() {
            return brushToString(this.i.p7);
        }
        set hoverBackgroundColor(v) {
            this.i.p7 = stringToBrush(v);
            this._a("hoverBackgroundColor", brushToString(this.i.p7));
        }
        /**
         * Gets or sets the border color to use for the button regardless of type.
        */
        get borderColor() {
            return brushToString(this.i.nt);
        }
        set borderColor(v) {
            this.i.nt = stringToBrush(v);
            this._a("borderColor", brushToString(this.i.nt));
        }
        /**
         * Gets or sets the elevation to use for the button regardless of type.
        */
        get restingElevation() {
            return this.i.d2;
        }
        set restingElevation(v) {
            this.i.d2 = +v;
            this._a("restingElevation", this.i.d2);
        }
        /**
         * Gets or sets the hover elevation to use for the button regardless of type.
        */
        get hoverElevation() {
            return this.i.dp;
        }
        set hoverElevation(v) {
            this.i.dp = +v;
            this._a("hoverElevation", this.i.dp);
        }
        /**
         * Gets or sets the focus elevation to use for the button regardless of type.
        */
        get focusElevation() {
            return this.i.dn;
        }
        set focusElevation(v) {
            this.i.dn = +v;
            this._a("focusElevation", this.i.dn);
        }
        /**
         * Gets or sets the use for the button.
        */
        get textStyle() {
            if (this.i.aa == null) {
                return null;
            }
            return this.i.aa.fontString;
        }
        set textStyle(v) {
            let fi = new FontInfo();
            fi.fontString = v;
            this.i.aa = fi;
            this._a("textStyle", this.i.aa != null ? this.i.aa.fontString : "");
        }
        /**
         * Gets or sets the color to use for the text of the button regardless of type.
        */
        get textColor() {
            return brushToString(this.i.q7);
        }
        set textColor(v) {
            this.i.q7 = stringToBrush(v);
            this._a("textColor", brushToString(this.i.q7));
        }
        /**
         * Gets or sets the color to use for the hovered text of the button regardless of type.
        */
        get hoverTextColor() {
            return brushToString(this.i.p8);
        }
        set hoverTextColor(v) {
            this.i.p8 = stringToBrush(v);
            this._a("hoverTextColor", brushToString(this.i.p8));
        }
        /**
         * Gets or sets the color to use for the background of the button regardless of type.
        */
        get rippleColor() {
            return brushToString(this.i.q6);
        }
        set rippleColor(v) {
            this.i.q6 = stringToBrush(v);
            this._a("rippleColor", brushToString(this.i.q6));
        }
        /**
         * Gets or sets the color to use for the text of the button when type is raised.
        */
        get raisedTextColor() {
            return brushToString(this.i.q5);
        }
        set raisedTextColor(v) {
            this.i.q5 = stringToBrush(v);
            this._a("raisedTextColor", brushToString(this.i.q5));
        }
        /**
         * Gets or sets the color to use for the hovered text of the button when type is raised.
        */
        get raisedHoverTextColor() {
            return brushToString(this.i.q3);
        }
        set raisedHoverTextColor(v) {
            this.i.q3 = stringToBrush(v);
            this._a("raisedHoverTextColor", brushToString(this.i.q3));
        }
        /**
         * Gets or sets the color to use for the backround the button when it is focused and raised.
        */
        get raisedFocusBackgroundColor() {
            return brushToString(this.i.q0);
        }
        set raisedFocusBackgroundColor(v) {
            this.i.q0 = stringToBrush(v);
            this._a("raisedFocusBackgroundColor", brushToString(this.i.q0));
        }
        /**
         * Gets or sets the color to use for the text the button when it is focused and raised.
        */
        get raisedFocusTextColor() {
            return brushToString(this.i.q1);
        }
        set raisedFocusTextColor(v) {
            this.i.q1 = stringToBrush(v);
            this._a("raisedFocusTextColor", brushToString(this.i.q1));
        }
        /**
         * Gets or sets the color to use for the backround the button when it is focused.
        */
        get focusBackgroundColor() {
            return brushToString(this.i.p5);
        }
        set focusBackgroundColor(v) {
            this.i.p5 = stringToBrush(v);
            this._a("focusBackgroundColor", brushToString(this.i.p5));
        }
        /**
         * Gets or sets the color to use for the text of the button when it is focused.
        */
        get focusTextColor() {
            return brushToString(this.i.p6);
        }
        set focusTextColor(v) {
            this.i.p6 = stringToBrush(v);
            this._a("focusTextColor", brushToString(this.i.p6));
        }
        /**
         * Gets or sets the width to use for the button border regardless of type.
        */
        get borderWidth() {
            return this.i.bg;
        }
        set borderWidth(v) {
            this.i.bg = +v;
            this._a("borderWidth", this.i.bg);
        }
        get cornerRadiusBottomRight() {
            return this.i.kt ? this.i.kt.b : NaN;
        }
        set cornerRadiusBottomRight(v) {
            this.ensureCornerRadius();
            this.i.kt.b = +v;
            this._a("cornerRadiusBottomRight", this.i.kt.b);
            this.i.kt = this.i.kt;
        }
        get cornerRadiusBottomLeft() {
            return this.i.kt ? this.i.kt.a : NaN;
        }
        set cornerRadiusBottomLeft(v) {
            this.ensureCornerRadius();
            this.i.kt.a = +v;
            this._a("cornerRadiusBottomLeft", this.i.kt.a);
            this.i.kt = this.i.kt;
        }
        get cornerRadiusTopLeft() {
            return this.i.kt ? this.i.kt.c : NaN;
        }
        set cornerRadiusTopLeft(v) {
            this.ensureCornerRadius();
            this.i.kt.c = +v;
            this._a("cornerRadiusTopLeft", this.i.kt.c);
            this.i.kt = this.i.kt;
        }
        get cornerRadiusTopRight() {
            return this.i.kt ? this.i.kt.d : NaN;
        }
        set cornerRadiusTopRight(v) {
            this.ensureCornerRadius();
            this.i.kt.d = +v;
            this._a("cornerRadiusTopRight", this.i.kt.d);
            this.i.kt = this.i.kt;
        }
        ensureCornerRadius() {
            if (this.i.kt) {
                return;
            }
            this.i.kt = new CornerRadius(2);
        }
        /**
         * Gets or sets the color to use for the background of the button when the  type is outlined.
        */
        get outlinedBackgroundColor() {
            return brushToString(this.i.qk);
        }
        set outlinedBackgroundColor(v) {
            this.i.qk = stringToBrush(v);
            this._a("outlinedBackgroundColor", brushToString(this.i.qk));
        }
        /**
         * Gets or sets the color to use for the disabled background of the button when the type is outlined.
        */
        get outlinedDisabledBackgroundColor() {
            return brushToString(this.i.qm);
        }
        set outlinedDisabledBackgroundColor(v) {
            this.i.qm = stringToBrush(v);
            this._a("outlinedDisabledBackgroundColor", brushToString(this.i.qm));
        }
        /**
         * Gets or sets the color to use for the disabled border of the button when the type is outlined.
        */
        get outlinedDisabledBorderColor() {
            return brushToString(this.i.qn);
        }
        set outlinedDisabledBorderColor(v) {
            this.i.qn = stringToBrush(v);
            this._a("outlinedDisabledBorderColor", brushToString(this.i.qn));
        }
        /**
         * Gets or sets the color to use for the disabled text of the button when the type is outlined.
        */
        get outlinedDisabledTextColor() {
            return brushToString(this.i.qo);
        }
        set outlinedDisabledTextColor(v) {
            this.i.qo = stringToBrush(v);
            this._a("outlinedDisabledTextColor", brushToString(this.i.qo));
        }
        /**
         * Gets or sets the disabled elevation to use for the button when the type is outlined.
        */
        get outlinedDisabledElevation() {
            return this.i.du;
        }
        set outlinedDisabledElevation(v) {
            this.i.du = +v;
            this._a("outlinedDisabledElevation", this.i.du);
        }
        /**
         * Gets or sets the hover color to use for the background of the button when the  type is hoveredOutlined.
        */
        get outlinedHoverBackgroundColor() {
            return brushToString(this.i.qr);
        }
        set outlinedHoverBackgroundColor(v) {
            this.i.qr = stringToBrush(v);
            this._a("outlinedHoverBackgroundColor", brushToString(this.i.qr));
        }
        /**
         * Gets or sets the border color to use for the button when the type is outlined.
        */
        get outlinedBorderColor() {
            return brushToString(this.i.ql);
        }
        set outlinedBorderColor(v) {
            this.i.ql = stringToBrush(v);
            this._a("outlinedBorderColor", brushToString(this.i.ql));
        }
        /**
         * Gets or sets the elevation to use for the button when the type is outlined.
        */
        get outlinedRestingElevation() {
            return this.i.dx;
        }
        set outlinedRestingElevation(v) {
            this.i.dx = +v;
            this._a("outlinedRestingElevation", this.i.dx);
        }
        /**
         * Gets or sets the hover elevation to use for the button when the type is outlined.
        */
        get outlinedHoverElevation() {
            return this.i.dw;
        }
        set outlinedHoverElevation(v) {
            this.i.dw = +v;
            this._a("outlinedHoverElevation", this.i.dw);
        }
        /**
         * Gets or sets the focus elevation to use for the button when the type is outlined.
        */
        get outlinedFocusElevation() {
            return this.i.dv;
        }
        set outlinedFocusElevation(v) {
            this.i.dv = +v;
            this._a("outlinedFocusElevation", this.i.dv);
        }
        /**
         * Gets or sets the width to use for the button border when the type is outlined.
        */
        get outlinedBorderWidth() {
            return this.i.bv;
        }
        set outlinedBorderWidth(v) {
            this.i.bv = +v;
            this._a("outlinedBorderWidth", this.i.bv);
        }
        get outlinedCornerRadiusBottomRight() {
            return this.i.k2 ? this.i.k2.b : NaN;
        }
        set outlinedCornerRadiusBottomRight(v) {
            this.ensureOutlinedCornerRadius();
            this.i.k2.b = +v;
            this._a("outlinedCornerRadiusBottomRight", this.i.k2.b);
            this.i.k2 = this.i.k2;
        }
        get outlinedCornerRadiusBottomLeft() {
            return this.i.k2 ? this.i.k2.a : NaN;
        }
        set outlinedCornerRadiusBottomLeft(v) {
            this.ensureOutlinedCornerRadius();
            this.i.k2.a = +v;
            this._a("outlinedCornerRadiusBottomLeft", this.i.k2.a);
            this.i.k2 = this.i.k2;
        }
        get outlinedCornerRadiusTopLeft() {
            return this.i.k2 ? this.i.k2.c : NaN;
        }
        set outlinedCornerRadiusTopLeft(v) {
            this.ensureOutlinedCornerRadius();
            this.i.k2.c = +v;
            this._a("outlinedCornerRadiusTopLeft", this.i.k2.c);
            this.i.k2 = this.i.k2;
        }
        get outlinedCornerRadiusTopRight() {
            return this.i.k2 ? this.i.k2.d : NaN;
        }
        set outlinedCornerRadiusTopRight(v) {
            this.ensureOutlinedCornerRadius();
            this.i.k2.d = +v;
            this._a("outlinedCornerRadiusTopRight", this.i.k2.d);
            this.i.k2 = this.i.k2;
        }
        ensureOutlinedCornerRadius() {
            if (this.i.k2) {
                return;
            }
            this.i.k2 = new CornerRadius(2);
        }
        /**
         * Gets or sets the color to use for the background when the button is pressed and the type is floating action button.
        */
        get outlinedRippleColor() {
            return brushToString(this.i.qt);
        }
        set outlinedRippleColor(v) {
            this.i.qt = stringToBrush(v);
            this._a("outlinedRippleColor", brushToString(this.i.qt));
        }
        /**
         * Gets or sets the color to use for the text of the button when type is outlined.
        */
        get outlinedTextColor() {
            return brushToString(this.i.qu);
        }
        set outlinedTextColor(v) {
            this.i.qu = stringToBrush(v);
            this._a("outlinedTextColor", brushToString(this.i.qu));
        }
        /**
         * Gets or sets the color to use for the hovered text of the button when type is outlined.
        */
        get outlinedHoverTextColor() {
            return brushToString(this.i.qs);
        }
        set outlinedHoverTextColor(v) {
            this.i.qs = stringToBrush(v);
            this._a("outlinedHoverTextColor", brushToString(this.i.qs));
        }
        /**
         * Gets or sets the color to use for the backround the button when it is focused and outlined.
        */
        get outlinedFocusBackgroundColor() {
            return brushToString(this.i.qp);
        }
        set outlinedFocusBackgroundColor(v) {
            this.i.qp = stringToBrush(v);
            this._a("outlinedFocusBackgroundColor", brushToString(this.i.qp));
        }
        /**
         * Gets or sets the color to use for the text the button when it is focused and outlined.
        */
        get outlinedFocusTextColor() {
            return brushToString(this.i.qq);
        }
        set outlinedFocusTextColor(v) {
            this.i.qq = stringToBrush(v);
            this._a("outlinedFocusTextColor", brushToString(this.i.qq));
        }
        /**
         * Gets or sets the color to use for the background of the button when the  type is floating action button.
        */
        get fabBackgroundColor() {
            return brushToString(this.i.pj);
        }
        set fabBackgroundColor(v) {
            this.i.pj = stringToBrush(v);
            this._a("fabBackgroundColor", brushToString(this.i.pj));
        }
        /**
         * Gets or sets the color to use for the disabled background of the button when the type is fab.
        */
        get fabDisabledBackgroundColor() {
            return brushToString(this.i.pl);
        }
        set fabDisabledBackgroundColor(v) {
            this.i.pl = stringToBrush(v);
            this._a("fabDisabledBackgroundColor", brushToString(this.i.pl));
        }
        /**
         * Gets or sets the color to use for the disabled border of the button when the type is fab.
        */
        get fabDisabledBorderColor() {
            return brushToString(this.i.pm);
        }
        set fabDisabledBorderColor(v) {
            this.i.pm = stringToBrush(v);
            this._a("fabDisabledBorderColor", brushToString(this.i.pm));
        }
        /**
         * Gets or sets the color to use for the disabled text of the button when the type is fab.
        */
        get fabDisabledTextColor() {
            return brushToString(this.i.pn);
        }
        set fabDisabledTextColor(v) {
            this.i.pn = stringToBrush(v);
            this._a("fabDisabledTextColor", brushToString(this.i.pn));
        }
        /**
         * Gets or sets the disabled elevation to use for the button when the type is fab.
        */
        get fabDisabledElevation() {
            return this.i.df;
        }
        set fabDisabledElevation(v) {
            this.i.df = +v;
            this._a("fabDisabledElevation", this.i.df);
        }
        /**
         * Gets or sets the hover color to use for the background of the button when the  type is hoveredFab.
        */
        get fabHoverBackgroundColor() {
            return brushToString(this.i.pq);
        }
        set fabHoverBackgroundColor(v) {
            this.i.pq = stringToBrush(v);
            this._a("fabHoverBackgroundColor", brushToString(this.i.pq));
        }
        /**
         * Gets or sets the border color to use for the button when the type is floating action button.
        */
        get fabBorderColor() {
            return brushToString(this.i.pk);
        }
        set fabBorderColor(v) {
            this.i.pk = stringToBrush(v);
            this._a("fabBorderColor", brushToString(this.i.pk));
        }
        /**
         * Gets or sets the elevation to use for the button when the type is floating action button.
        */
        get fabRestingElevation() {
            return this.i.di;
        }
        set fabRestingElevation(v) {
            this.i.di = +v;
            this._a("fabRestingElevation", this.i.di);
        }
        /**
         * Gets or sets the hover elevation to use for the button when the type is floating action button.
        */
        get fabHoverElevation() {
            return this.i.dh;
        }
        set fabHoverElevation(v) {
            this.i.dh = +v;
            this._a("fabHoverElevation", this.i.dh);
        }
        /**
         * Gets or sets the focus elevation to use for the button when the type is floating action button.
        */
        get fabFocusElevation() {
            return this.i.dg;
        }
        set fabFocusElevation(v) {
            this.i.dg = +v;
            this._a("fabFocusElevation", this.i.dg);
        }
        /**
         * Gets or sets the width to use for the button border when the type is floating action button.
        */
        get fabBorderWidth() {
            return this.i.bq;
        }
        set fabBorderWidth(v) {
            this.i.bq = +v;
            this._a("fabBorderWidth", this.i.bq);
        }
        get fabCornerRadiusBottomRight() {
            return this.i.kz ? this.i.kz.b : NaN;
        }
        set fabCornerRadiusBottomRight(v) {
            this.ensureFabCornerRadius();
            this.i.kz.b = +v;
            this._a("fabCornerRadiusBottomRight", this.i.kz.b);
            this.i.kz = this.i.kz;
        }
        get fabCornerRadiusBottomLeft() {
            return this.i.kz ? this.i.kz.a : NaN;
        }
        set fabCornerRadiusBottomLeft(v) {
            this.ensureFabCornerRadius();
            this.i.kz.a = +v;
            this._a("fabCornerRadiusBottomLeft", this.i.kz.a);
            this.i.kz = this.i.kz;
        }
        get fabCornerRadiusTopLeft() {
            return this.i.kz ? this.i.kz.c : NaN;
        }
        set fabCornerRadiusTopLeft(v) {
            this.ensureFabCornerRadius();
            this.i.kz.c = +v;
            this._a("fabCornerRadiusTopLeft", this.i.kz.c);
            this.i.kz = this.i.kz;
        }
        get fabCornerRadiusTopRight() {
            return this.i.kz ? this.i.kz.d : NaN;
        }
        set fabCornerRadiusTopRight(v) {
            this.ensureFabCornerRadius();
            this.i.kz.d = +v;
            this._a("fabCornerRadiusTopRight", this.i.kz.d);
            this.i.kz = this.i.kz;
        }
        ensureFabCornerRadius() {
            if (this.i.kz) {
                return;
            }
            this.i.kz = new CornerRadius(2);
        }
        /**
         * Gets or sets the color to use for the background when the button is pressed and the type is floating action button.
        */
        get fabRippleColor() {
            return brushToString(this.i.ps);
        }
        set fabRippleColor(v) {
            this.i.ps = stringToBrush(v);
            this._a("fabRippleColor", brushToString(this.i.ps));
        }
        /**
         * Gets or sets the color to use for the text of the button when type is floating action button.
        */
        get fabTextColor() {
            return brushToString(this.i.pt);
        }
        set fabTextColor(v) {
            this.i.pt = stringToBrush(v);
            this._a("fabTextColor", brushToString(this.i.pt));
        }
        /**
         * Gets or sets the color to use for the hovered text of the button when type is floating action button.
        */
        get fabHoverTextColor() {
            return brushToString(this.i.pr);
        }
        set fabHoverTextColor(v) {
            this.i.pr = stringToBrush(v);
            this._a("fabHoverTextColor", brushToString(this.i.pr));
        }
        /**
         * Gets or sets the color to use for the backround the button when it is focused and fab.
        */
        get fabFocusBackgroundColor() {
            return brushToString(this.i.po);
        }
        set fabFocusBackgroundColor(v) {
            this.i.po = stringToBrush(v);
            this._a("fabFocusBackgroundColor", brushToString(this.i.po));
        }
        /**
         * Gets or sets the color to use for the text the button when it is focused and fab.
        */
        get fabFocusTextColor() {
            return brushToString(this.i.pp);
        }
        set fabFocusTextColor(v) {
            this.i.pp = stringToBrush(v);
            this._a("fabFocusTextColor", brushToString(this.i.pp));
        }
        /**
         * Gets or sets the color to use for the background of the button when the  type is icon.
        */
        get iconBackgroundColor() {
            return brushToString(this.i.p9);
        }
        set iconBackgroundColor(v) {
            this.i.p9 = stringToBrush(v);
            this._a("iconBackgroundColor", brushToString(this.i.p9));
        }
        /**
         * Gets or sets the color to use for the disabled background of the button when the type is icon.
        */
        get iconDisabledBackgroundColor() {
            return brushToString(this.i.qb);
        }
        set iconDisabledBackgroundColor(v) {
            this.i.qb = stringToBrush(v);
            this._a("iconDisabledBackgroundColor", brushToString(this.i.qb));
        }
        /**
         * Gets or sets the color to use for the disabled border of the button when the type is icon.
        */
        get iconDisabledBorderColor() {
            return brushToString(this.i.qc);
        }
        set iconDisabledBorderColor(v) {
            this.i.qc = stringToBrush(v);
            this._a("iconDisabledBorderColor", brushToString(this.i.qc));
        }
        /**
         * Gets or sets the color to use for the disabled text of the button when the type is icon.
        */
        get iconDisabledTextColor() {
            return brushToString(this.i.qd);
        }
        set iconDisabledTextColor(v) {
            this.i.qd = stringToBrush(v);
            this._a("iconDisabledTextColor", brushToString(this.i.qd));
        }
        /**
         * Gets or sets the disabled elevation to use for the button when the type is icon.
        */
        get iconDisabledElevation() {
            return this.i.dq;
        }
        set iconDisabledElevation(v) {
            this.i.dq = +v;
            this._a("iconDisabledElevation", this.i.dq);
        }
        /**
         * Gets or sets the hover color to use for the background of the button when the  type is hoveredIcon.
        */
        get iconHoverBackgroundColor() {
            return brushToString(this.i.qg);
        }
        set iconHoverBackgroundColor(v) {
            this.i.qg = stringToBrush(v);
            this._a("iconHoverBackgroundColor", brushToString(this.i.qg));
        }
        /**
         * Gets or sets the border color to use for the button when the type is icon.
        */
        get iconBorderColor() {
            return brushToString(this.i.qa);
        }
        set iconBorderColor(v) {
            this.i.qa = stringToBrush(v);
            this._a("iconBorderColor", brushToString(this.i.qa));
        }
        /**
         * Gets or sets the elevation to use for the button when the type is icon.
        */
        get iconRestingElevation() {
            return this.i.dt;
        }
        set iconRestingElevation(v) {
            this.i.dt = +v;
            this._a("iconRestingElevation", this.i.dt);
        }
        /**
         * Gets or sets the hover elevation to use for the button when the type is icon.
        */
        get iconHoverElevation() {
            return this.i.ds;
        }
        set iconHoverElevation(v) {
            this.i.ds = +v;
            this._a("iconHoverElevation", this.i.ds);
        }
        /**
         * Gets or sets the focus elevation to use for the button when the type is icon.
        */
        get iconFocusElevation() {
            return this.i.dr;
        }
        set iconFocusElevation(v) {
            this.i.dr = +v;
            this._a("iconFocusElevation", this.i.dr);
        }
        /**
         * Gets or sets the width to use for the button border when the type is icon.
        */
        get iconBorderWidth() {
            return this.i.bs;
        }
        set iconBorderWidth(v) {
            this.i.bs = +v;
            this._a("iconBorderWidth", this.i.bs);
        }
        get iconCornerRadiusBottomRight() {
            return this.i.k1 ? this.i.k1.b : NaN;
        }
        set iconCornerRadiusBottomRight(v) {
            this.ensureIconCornerRadius();
            this.i.k1.b = +v;
            this._a("iconCornerRadiusBottomRight", this.i.k1.b);
            this.i.k1 = this.i.k1;
        }
        get iconCornerRadiusBottomLeft() {
            return this.i.k1 ? this.i.k1.a : NaN;
        }
        set iconCornerRadiusBottomLeft(v) {
            this.ensureIconCornerRadius();
            this.i.k1.a = +v;
            this._a("iconCornerRadiusBottomLeft", this.i.k1.a);
            this.i.k1 = this.i.k1;
        }
        get iconCornerRadiusTopLeft() {
            return this.i.k1 ? this.i.k1.c : NaN;
        }
        set iconCornerRadiusTopLeft(v) {
            this.ensureIconCornerRadius();
            this.i.k1.c = +v;
            this._a("iconCornerRadiusTopLeft", this.i.k1.c);
            this.i.k1 = this.i.k1;
        }
        get iconCornerRadiusTopRight() {
            return this.i.k1 ? this.i.k1.d : NaN;
        }
        set iconCornerRadiusTopRight(v) {
            this.ensureIconCornerRadius();
            this.i.k1.d = +v;
            this._a("iconCornerRadiusTopRight", this.i.k1.d);
            this.i.k1 = this.i.k1;
        }
        ensureIconCornerRadius() {
            if (this.i.k1) {
                return;
            }
            this.i.k1 = new CornerRadius(2);
        }
        /**
         * Gets or sets the color to use for the background when the button is pressed and the type is floating action button.
        */
        get iconRippleColor() {
            return brushToString(this.i.qi);
        }
        set iconRippleColor(v) {
            this.i.qi = stringToBrush(v);
            this._a("iconRippleColor", brushToString(this.i.qi));
        }
        /**
         * Gets or sets the color to use for the text of the button when type is icon.
        */
        get iconTextColor() {
            return brushToString(this.i.qj);
        }
        set iconTextColor(v) {
            this.i.qj = stringToBrush(v);
            this._a("iconTextColor", brushToString(this.i.qj));
        }
        /**
         * Gets or sets the color to use for the hovered text of the button when type is icon.
        */
        get iconHoverTextColor() {
            return brushToString(this.i.qh);
        }
        set iconHoverTextColor(v) {
            this.i.qh = stringToBrush(v);
            this._a("iconHoverTextColor", brushToString(this.i.qh));
        }
        /**
         * Gets or sets the color to use for the backround the button when it is focused and icon.
        */
        get iconFocusBackgroundColor() {
            return brushToString(this.i.qe);
        }
        set iconFocusBackgroundColor(v) {
            this.i.qe = stringToBrush(v);
            this._a("iconFocusBackgroundColor", brushToString(this.i.qe));
        }
        /**
         * Gets or sets the color to use for the text the button when it is focused and icon.
        */
        get iconFocusTextColor() {
            return brushToString(this.i.qf);
        }
        set iconFocusTextColor(v) {
            this.i.qf = stringToBrush(v);
            this._a("iconFocusTextColor", brushToString(this.i.qf));
        }
        /**
         * Gets or sets the id to use for the internal native checkbox.
        */
        get inputId() {
            return this.i.hu;
        }
        set inputId(v) {
            this.i.hu = v;
        }
        /**
         * Gets or sets the id to use for the checkbox.
        */
        get id() {
            return this.i.hs;
        }
        set id(v) {
            this.i.hs = v;
        }
        /**
         * Gets or sets the id to use for the checkbox.
        */
        get display() {
            return this.i.fw;
        }
        set display(v) {
            this.i.fw = v;
        }
        /**
         * Gets or sets the id to use for the checkbox.
        */
        get flexDirection() {
            return this.i.g0;
        }
        set flexDirection(v) {
            this.i.g0 = v;
        }
        /**
         * Gets or sets the flex-grow setting for the button.
        */
        get flexGrow() {
            return this.i.g2;
        }
        set flexGrow(v) {
            this.i.g2 = v;
        }
        /**
         * Gets or sets the id to use for the checkbox.
        */
        get alignItems() {
            return this.i.e7;
        }
        set alignItems(v) {
            this.i.e7 = v;
        }
        /**
         * Gets or sets value to use for the checkbox.
        */
        get value() {
            return this.i.ea;
        }
        set value(v) {
            this.i.ea = v;
        }
        /**
         * Gets or sets name to use for the button.
        */
        get name() {
            return this.i.h2;
        }
        set name(v) {
            this.i.h2 = v;
        }
        /**
         * Gets or sets TabIndex to use for the checkbox.
        */
        get tabIndex() {
            return this.i.d3;
        }
        set tabIndex(v) {
            this.i.d3 = +v;
            this._a("tabIndex", this.i.d3);
        }
        /**
         * Gets or sets the value of the aria-label attribute.
        */
        get ariaLabel() {
            return this.i.e9;
        }
        set ariaLabel(v) {
            this.i.e9 = v;
        }
        /**
         * Gets or sets whether the button should fill the available space. If false, the button
         * will use an intrinsic size.
        */
        get fillAvailableSpace() {
            return this.i.av;
        }
        set fillAvailableSpace(v) {
            this.i.av = ensureBool(v);
            this._a("fillAvailableSpace", this.i.av);
        }
        /**
         * Gets or sets if the checkbox is Focused.
        */
        get focused() {
            return this.i.focused;
        }
        set focused(v) {
            this.i.focused = ensureBool(v);
            this._a("focused", this.i.focused);
        }
        /**
         * Gets or sets if the button show use styling to show focus.
        */
        get isFocusStyleEnabled() {
            return this.i.az;
        }
        set isFocusStyleEnabled(v) {
            this.i.az = ensureBool(v);
            this._a("isFocusStyleEnabled", this.i.az);
        }
        /**
         * Gets or sets whether to disable the ripple effect for the button.
        */
        get disableRipple() {
            return this.i.at;
        }
        set disableRipple(v) {
            this.i.at = ensureBool(v);
            this._a("disableRipple", this.i.at);
        }
        /**
         * Gets whether to actually disable the ripple effect for the button.
        */
        get actualDisableRipple() {
            return this.i.ap;
        }
        set actualDisableRipple(v) {
            this.i.ap = ensureBool(v);
            this._a("actualDisableRipple", this.i.ap);
        }
        /**
         * Gets or sets whether the hover effect is disabled.
        */
        get disableHover() {
            return this.i.ar;
        }
        set disableHover(v) {
            this.i.ar = ensureBool(v);
            this._a("disableHover", this.i.ar);
        }
        /**
         * Gets or sets whether the checkbox is checked.
        */
        get isHover() {
            return this.i.a0;
        }
        set isHover(v) {
            this.i.a0 = ensureBool(v);
            this._a("isHover", this.i.a0);
        }
        /**
         * Gets or sets whether the checkbox is disabled.
        */
        get disabled() {
            return this.i.disabled;
        }
        set disabled(v) {
            this.i.disabled = ensureBool(v);
            this._a("disabled", this.i.disabled);
        }
        /**
         * Gets or sets whether the checkbox transitions are disabled.
        */
        get disableTransitions() {
            return this.i.au;
        }
        set disableTransitions(v) {
            this.i.au = ensureBool(v);
            this._a("disableTransitions", this.i.au);
        }
        /**
         * Gets or sets whether the cursor will change into a pointer when the button is hovered.
        */
        get disablePointer() {
            return this.i.as;
        }
        set disablePointer(v) {
            this.i.as = ensureBool(v);
            this._a("disablePointer", this.i.as);
        }
        /**
         * Gets or sets the left padding for the button content.
        */
        get contentPaddingLeft() {
            return this.i.bi;
        }
        set contentPaddingLeft(v) {
            this.i.bi = +v;
            this._a("contentPaddingLeft", this.i.bi);
        }
        /**
         * Gets or sets the top padding for the button content.
        */
        get contentPaddingTop() {
            return this.i.bk;
        }
        set contentPaddingTop(v) {
            this.i.bk = +v;
            this._a("contentPaddingTop", this.i.bk);
        }
        /**
         * Gets or sets the right padding for the button content.
        */
        get contentPaddingRight() {
            return this.i.bj;
        }
        set contentPaddingRight(v) {
            this.i.bj = +v;
            this._a("contentPaddingRight", this.i.bj);
        }
        /**
         * Gets or sets the bottom padding for the button content.
        */
        get contentPaddingBottom() {
            return this.i.bh;
        }
        set contentPaddingBottom(v) {
            this.i.bh = +v;
            this._a("contentPaddingBottom", this.i.bh);
        }
        get horizontalContentAlignment() {
            return this.i.k5;
        }
        set horizontalContentAlignment(v) {
            this.i.k5 = ensureEnum(HorizontalAlignment_$type, v);
            this._a("horizontalContentAlignment", enumToString(HorizontalAlignment_$type, this.i.k5));
        }
        get verticalContentAlignment() {
            return this.i.q9;
        }
        set verticalContentAlignment(v) {
            this.i.q9 = ensureEnum(VerticalAlignment_$type, v);
            this._a("verticalContentAlignment", enumToString(VerticalAlignment_$type, this.i.q9));
        }
        /**
         * Gets or sets if clicking on the button is allowed to tunnel down to button content.
        */
        get clickTunneling() {
            return this.i.aq;
        }
        set clickTunneling(v) {
            this.i.aq = ensureBool(v);
            this._a("clickTunneling", this.i.aq);
        }
        findByName(name) {
            if (this.findEphemera) {
                if (name && name.indexOf("@@e:") == 0) {
                    return this.findEphemera(name);
                }
            }
            return null;
        }
        get hasUserValues() {
            return this._hasUserValues;
        }
        __m(propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        }
        _styling(container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            let genericPrefix = "";
            let typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = toSpinal("XButtonComponent");
            let additionalPrefixes = [];
            let prefix = toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            let b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                let basePrefix = toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                let parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                let parentPrefix = toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        }
        onDetachedFromUI() {
            this.i.onDetachedFromUI();
        }
        onAttachedToUI() {
            this.i.onAttachedToUI();
        }
        /**
         * Exports visual information about the current state of the grid.
        
        */
        exportVisualModel() {
            let iv = this.i.d7();
            return (iv);
        }
        /**
         * Returns a serialized copy of the exported visual model
        
        */
        exportSerializedVisualModel() {
            let iv = this.i.f0();
            return (iv);
        }
        get clicked() {
            return this._clicked;
        }
        set clicked(ev) {
            if (this._clicked_wrapped !== null) {
                this.i.clicked = delegateRemove(this.i.clicked, this._clicked_wrapped);
                this._clicked_wrapped = null;
                this._clicked = null;
            }
            this._clicked = ev;
            this._clicked_wrapped = (o, e) => {
                let outerArgs = new IgcButtonClickEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeClicked) {
                    this.beforeClicked(this, outerArgs);
                }
                if (this._clicked) {
                    this._clicked(this, outerArgs);
                }
            };
            this.i.clicked = delegateCombine(this.i.clicked, this._clicked_wrapped);
            ;
        }
        get gotFocus() {
            return this._gotFocus;
        }
        set gotFocus(ev) {
            if (this._gotFocus_wrapped !== null) {
                this.i.gotFocus = delegateRemove(this.i.gotFocus, this._gotFocus_wrapped);
                this._gotFocus_wrapped = null;
                this._gotFocus = null;
            }
            this._gotFocus = ev;
            this._gotFocus_wrapped = (o, e) => {
                let outerArgs = new IgcFocusEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeGotFocus) {
                    this.beforeGotFocus(this, outerArgs);
                }
                if (this._gotFocus) {
                    this._gotFocus(this, outerArgs);
                }
            };
            this.i.gotFocus = delegateCombine(this.i.gotFocus, this._gotFocus_wrapped);
            ;
        }
        get lostFocus() {
            return this._lostFocus;
        }
        set lostFocus(ev) {
            if (this._lostFocus_wrapped !== null) {
                this.i.lostFocus = delegateRemove(this.i.lostFocus, this._lostFocus_wrapped);
                this._lostFocus_wrapped = null;
                this._lostFocus = null;
            }
            this._lostFocus = ev;
            this._lostFocus_wrapped = (o, e) => {
                let outerArgs = new IgcFocusEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeLostFocus) {
                    this.beforeLostFocus(this, outerArgs);
                }
                if (this._lostFocus) {
                    this._lostFocus(this, outerArgs);
                }
            };
            this.i.lostFocus = delegateCombine(this.i.lostFocus, this._lostFocus_wrapped);
            ;
        }
    }
    IgcXButtonComponent._observedAttributesIgcXButtonComponent = null;
    IgcXButtonComponent.htmlTagName = "igc-x-button";
    IgcXButtonComponent._isElementRegistered = false;
    return IgcXButtonComponent;
})();
