import { __extends, __values } from "tslib";
import { XButton } from "./XButton";
import { ensureEnum, brushToString, stringToBrush, ensureBool, initializePropertiesFromCss, NamePatcher, toSpinal, enumToString, getAllPropertyNames, fromSpinal } from "igniteui-webcomponents-core";
import { FontInfo } from "igniteui-webcomponents-core";
import { WebComponentRenderer, PortalManager } from "igniteui-webcomponents-core";
import { delegateCombine, delegateRemove } from "igniteui-webcomponents-core";
import { TypeRegistrar } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
import { CornerRadius } from "igniteui-webcomponents-core";
import { ButtonDisplayStyle_$type } from './ButtonDisplayStyle';
import { IgcButtonClickEventArgs } from './igc-button-click-event-args';
import { ControlDisplayDensity_$type } from "igniteui-webcomponents-core";
import { BaseControlTheme_$type } from "igniteui-webcomponents-core";
import { ElevationMode_$type } from "igniteui-webcomponents-core";
import { IgcHTMLElement } from "igniteui-webcomponents-core";
import { HorizontalAlignment_$type } from "igniteui-webcomponents-core";
import { VerticalAlignment_$type } from "igniteui-webcomponents-core";
import { IgcFocusEventArgs } from "igniteui-webcomponents-core";
var IgcXButtonComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcXButtonComponent, _super);
    function IgcXButtonComponent() {
        var _this = _super.call(this) || this;
        _this._disconnected = false;
        _this._settingAttributes = false;
        _this._attached = false;
        _this._queuedSetAttributes = [];
        _this._updatingFromAttribute = false;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        _this._clicked = null;
        _this._clicked_wrapped = null;
        _this._gotFocus = null;
        _this._gotFocus_wrapped = null;
        _this._lostFocus = null;
        _this._lostFocus_wrapped = null;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._portalManager = new PortalManager("buttonContent");
        _this._renderer = new WebComponentRenderer(_this, document, true, {}, _this._portalManager);
        _this._container = _this._renderer.createElement("div");
        _this._renderer.updateRoot(_this._container);
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        //this._container.setStyleProperty("width", "100%");
        //this._container.setStyleProperty("height", "100%");
        var root;
        root = _this._container;
        if (_this._container.getNativeElement() != null) {
            root = _this._container.getNativeElement();
        }
        _this._wrapper = _this._renderer;
        var button = _this.i;
        _this._button = button;
        button.provideContainer(_this._renderer);
        _this._onChildrenChanged();
        //Checkbox.notifySizeChanged();
        var mut = new MutationObserver(function (list) {
            var e_1, _b;
            try {
                for (var list_1 = __values(list), list_1_1 = list_1.next(); !list_1_1.done; list_1_1 = list_1.next()) {
                    var mutation = list_1_1.value;
                    if (mutation.type == 'childList') {
                        _this._onChildrenChanged();
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (list_1_1 && !list_1_1.done && (_b = list_1.return))
                        _b.call(list_1);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        });
        mut.observe(_this, {
            childList: true
        });
        return _this;
        //this._renderer.addSizeWatcher(() => {
        //    this._checkbox.notifySizeChanged();
        //});
    }
    IgcXButtonComponent.prototype._onDisplayChanged = function () {
        this.style.display = this.display;
    };
    IgcXButtonComponent.prototype._onFlexDirectionChanged = function () {
        this.style.flexDirection = this.flexDirection;
    };
    IgcXButtonComponent.prototype._onFlexGrowChanged = function () {
        this.style.flexGrow = this.flexGrow;
    };
    IgcXButtonComponent.prototype._onAlignItemsChanged = function () {
        this.style.alignItems = this.alignItems;
    };
    IgcXButtonComponent.prototype._onChildrenChanged = function () {
        var children = [];
        for (var i = 0; i < this.childNodes.length; i++) {
            var child = this.childNodes[i];
            if (child !== this._container.getNativeElement()) {
                children.push(child);
            }
        }
        this._portalManager.onChildrenChanged(children);
    };
    // supports angular themes or custom properties set in CSS
    IgcXButtonComponent.prototype.updateStyle = function () {
        this._styling(this, this);
    };
    IgcXButtonComponent.prototype.destroy = function () {
        this._button.destroy();
        this._wrapper.destroy();
    };
    IgcXButtonComponent.prototype.createImplementation = function () {
        return new XButton();
    };
    IgcXButtonComponent.prototype.disconnectedCallback = function () {
        this._disconnected = true;
        if (this.i) {
            this.i.onDetachedFromUI();
        }
    };
    IgcXButtonComponent.prototype.connectedCallback = function () {
        if (this._disconnected) {
            this._disconnected = false;
            if (this.i) {
                this.i.onAttachedToUI();
            }
            return;
        }
        this.classList.add("ig-x-button");
        this.classList.add("igc-x-button");
        this.appendChild(this._container.getNativeElement());
        this._attached = true;
        this.style.display = this.display;
        //this.style.height = this._height;
        //this.style.width = this._width;
        this._flushQueuedAttributes();
        // supports themes or custom properties set in CSS 
        this._styling(this, this);
        this.afterContentInit();
    };
    IgcXButtonComponent.prototype.afterContentInit = function () {
        //this.i.notifySizeChanged();
    };
    Object.defineProperty(IgcXButtonComponent.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        } /**
                                     * @hidden
                                     */,
        enumerable: false,
        configurable: true
    });
    IgcXButtonComponent._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igc" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    IgcXButtonComponent.prototype._enqueueSetAttribute = function (attrName, attrValue) {
        this._queuedSetAttributes.push({ attrName: attrName, attrValue: attrValue });
    };
    IgcXButtonComponent.prototype._flushQueuedAttributes = function () {
        this._settingAttributes = true;
        for (var i = 0; i < this._queuedSetAttributes.length; i++) {
            this.setAttribute(this._queuedSetAttributes[i].attrName, this._queuedSetAttributes[i].attrValue);
        }
        this._settingAttributes = false;
        this._queuedSetAttributes.length = 0;
    };
    IgcXButtonComponent.prototype._a = function (attrName, attrValue) {
        if (this._updatingFromAttribute) {
            return;
        }
        if (attrValue) {
            attrValue = attrValue.toString();
        }
        this._settingAttributes = true;
        attrName = toSpinal(attrName);
        if (this._attached) {
            this.setAttribute(attrName, attrValue);
        }
        else {
            this._enqueueSetAttribute(attrName, attrValue);
        }
        this._settingAttributes = false;
    };
    Object.defineProperty(IgcXButtonComponent, "observedAttributes", {
        get: function () {
            if (IgcXButtonComponent._observedAttributesIgcXButtonComponent == null) {
                var names = getAllPropertyNames(IgcXButtonComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcXButtonComponent._observedAttributesIgcXButtonComponent = names;
            }
            return IgcXButtonComponent._observedAttributesIgcXButtonComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcXButtonComponent.prototype.attributeChangedCallback = function (name, oldValue, newValue) {
        if (this._settingAttributes) {
            return;
        }
        var setName = fromSpinal(name);
        this._updatingFromAttribute = true;
        this[setName] = newValue;
        this._updatingFromAttribute = false;
    };
    IgcXButtonComponent.register = function () {
        if (!IgcXButtonComponent._isElementRegistered) {
            IgcXButtonComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcXButtonComponent.htmlTagName, IgcXButtonComponent);
        }
    };
    Object.defineProperty(IgcXButtonComponent.prototype, "minWidth", {
        /**
     * Gets or sets the min width to use for the button.
    */
        get: function () {
            return this.i.bu;
        },
        set: function (v) {
            this.i.bu = +v;
            this._a("minWidth", this.i.bu);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "minHeight", {
        /**
         * Gets or sets the min height to use for the button.
        */
        get: function () {
            return this.i.bt;
        },
        set: function (v) {
            this.i.bt = +v;
            this._a("minHeight", this.i.bt);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "displayType", {
        /**
         * Gets or sets the display style to use for the button.
        */
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = ensureEnum(ButtonDisplayStyle_$type, v);
            this._a("displayType", enumToString(ButtonDisplayStyle_$type, this.i.e));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "density", {
        /**
         * Gets or sets the display density to use for the button.
        */
        get: function () {
            return this.i.r;
        },
        set: function (v) {
            this.i.r = ensureEnum(ControlDisplayDensity_$type, v);
            this._a("density", enumToString(ControlDisplayDensity_$type, this.i.r));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "baseTheme", {
        /**
         * Gets or sets the base built in theme to use for the button.
        */
        get: function () {
            return this.i.n;
        },
        set: function (v) {
            this.i.n = ensureEnum(BaseControlTheme_$type, v);
            this._a("baseTheme", enumToString(BaseControlTheme_$type, this.i.n));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualDensity", {
        /**
         * Gets the actual display density to use for the label.
        */
        get: function () {
            return this.i.q;
        },
        set: function (v) {
            this.i.q = ensureEnum(ControlDisplayDensity_$type, v);
            this._a("actualDensity", enumToString(ControlDisplayDensity_$type, this.i.q));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualBorderColor", {
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get: function () {
            return brushToString(this.i.ng);
        },
        set: function (v) {
            this.i.ng = stringToBrush(v);
            this._a("actualBorderColor", brushToString(this.i.ng));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualUmbraShadowColor", {
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get: function () {
            return brushToString(this.i.nr);
        },
        set: function (v) {
            this.i.nr = stringToBrush(v);
            this._a("actualUmbraShadowColor", brushToString(this.i.nr));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualPenumbraShadowColor", {
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get: function () {
            return brushToString(this.i.no);
        },
        set: function (v) {
            this.i.no = stringToBrush(v);
            this._a("actualPenumbraShadowColor", brushToString(this.i.no));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualAmbientShadowColor", {
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get: function () {
            return brushToString(this.i.ne);
        },
        set: function (v) {
            this.i.ne = stringToBrush(v);
            this._a("actualAmbientShadowColor", brushToString(this.i.ne));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualRestingElevation", {
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get: function () {
            return this.i.ct;
        },
        set: function (v) {
            this.i.ct = +v;
            this._a("actualRestingElevation", this.i.ct);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualFocusElevation", {
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get: function () {
            return this.i.cr;
        },
        set: function (v) {
            this.i.cr = +v;
            this._a("actualFocusElevation", this.i.cr);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualHoverElevation", {
        /**
         * Gets or sets the color to use for the check mark when the checkbox is checked.
        */
        get: function () {
            return this.i.cs;
        },
        set: function (v) {
            this.i.cs = +v;
            this._a("actualHoverElevation", this.i.cs);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualRippleColor", {
        /**
         * Gets or sets the color to use for the ripple when the button is pressed.
        */
        get: function () {
            return brushToString(this.i.np);
        },
        set: function (v) {
            this.i.np = stringToBrush(v);
            this._a("actualRippleColor", brushToString(this.i.np));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualCornerRadiusBottomRight", {
        get: function () {
            return this.i.kr ? this.i.kr.b : NaN;
        },
        set: function (v) {
            this.ensureActualCornerRadius();
            this.i.kr.b = +v;
            this._a("actualCornerRadiusBottomRight", this.i.kr.b);
            this.i.kr = this.i.kr;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualCornerRadiusBottomLeft", {
        get: function () {
            return this.i.kr ? this.i.kr.a : NaN;
        },
        set: function (v) {
            this.ensureActualCornerRadius();
            this.i.kr.a = +v;
            this._a("actualCornerRadiusBottomLeft", this.i.kr.a);
            this.i.kr = this.i.kr;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualCornerRadiusTopLeft", {
        get: function () {
            return this.i.kr ? this.i.kr.c : NaN;
        },
        set: function (v) {
            this.ensureActualCornerRadius();
            this.i.kr.c = +v;
            this._a("actualCornerRadiusTopLeft", this.i.kr.c);
            this.i.kr = this.i.kr;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualCornerRadiusTopRight", {
        get: function () {
            return this.i.kr ? this.i.kr.d : NaN;
        },
        set: function (v) {
            this.ensureActualCornerRadius();
            this.i.kr.d = +v;
            this._a("actualCornerRadiusTopRight", this.i.kr.d);
            this.i.kr = this.i.kr;
        },
        enumerable: false,
        configurable: true
    });
    IgcXButtonComponent.prototype.ensureActualCornerRadius = function () {
        if (this.i.kr) {
            return;
        }
        this.i.kr = new CornerRadius(2);
    };
    Object.defineProperty(IgcXButtonComponent.prototype, "actualBackgroundColor", {
        /**
         * Gets the color to use for the actual background.
        */
        get: function () {
            return brushToString(this.i.nf);
        },
        set: function (v) {
            this.i.nf = stringToBrush(v);
            this._a("actualBackgroundColor", brushToString(this.i.nf));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualDisabledBackgroundColor", {
        /**
         * Gets the actual color to use for the disabled background of the button.
        */
        get: function () {
            return brushToString(this.i.nh);
        },
        set: function (v) {
            this.i.nh = stringToBrush(v);
            this._a("actualDisabledBackgroundColor", brushToString(this.i.nh));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualDisabledBorderColor", {
        /**
         * Gets the actual color to use for the disabled border of the button.
        */
        get: function () {
            return brushToString(this.i.ni);
        },
        set: function (v) {
            this.i.ni = stringToBrush(v);
            this._a("actualDisabledBorderColor", brushToString(this.i.ni));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualDisabledTextColor", {
        /**
         * Gets the actual color to use for the disabled text of the button.
        */
        get: function () {
            return brushToString(this.i.nj);
        },
        set: function (v) {
            this.i.nj = stringToBrush(v);
            this._a("actualDisabledTextColor", brushToString(this.i.nj));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualDisabledElevation", {
        /**
         * Gets the actual disabled elevation to use for the button.
        */
        get: function () {
            return this.i.cq;
        },
        set: function (v) {
            this.i.cq = +v;
            this._a("actualDisabledElevation", this.i.cq);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualElevationMode", {
        /**
         * Gets the actual disabled elevation to use for the button.
        */
        get: function () {
            return this.i.u;
        },
        set: function (v) {
            this.i.u = ensureEnum(ElevationMode_$type, v);
            this._a("actualElevationMode", enumToString(ElevationMode_$type, this.i.u));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualTextColor", {
        /**
         * Gets the color to use for the actual background.
        */
        get: function () {
            return brushToString(this.i.nq);
        },
        set: function (v) {
            this.i.nq = stringToBrush(v);
            this._a("actualTextColor", brushToString(this.i.nq));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualHoverTextColor", {
        /**
         * Gets the color to use for the actual background.
        */
        get: function () {
            return brushToString(this.i.nn);
        },
        set: function (v) {
            this.i.nn = stringToBrush(v);
            this._a("actualHoverTextColor", brushToString(this.i.nn));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualFocusBackgroundColor", {
        /**
         * Gets the color to use for the actual background.
        */
        get: function () {
            return brushToString(this.i.nk);
        },
        set: function (v) {
            this.i.nk = stringToBrush(v);
            this._a("actualFocusBackgroundColor", brushToString(this.i.nk));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualFocusTextColor", {
        /**
         * Gets the actual color to use for the focused text.
        */
        get: function () {
            return brushToString(this.i.nl);
        },
        set: function (v) {
            this.i.nl = stringToBrush(v);
            this._a("actualFocusTextColor", brushToString(this.i.nl));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualHoverBackgroundColor", {
        /**
         * Gets the hover color to use for the actual background.
        */
        get: function () {
            return brushToString(this.i.nm);
        },
        set: function (v) {
            this.i.nm = stringToBrush(v);
            this._a("actualHoverBackgroundColor", brushToString(this.i.nm));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualBorderWidth", {
        /**
         * Gets or sets the Width to use for the check mark when the checkbox is checked.
        */
        get: function () {
            return this.i.bf;
        },
        set: function (v) {
            this.i.bf = +v;
            this._a("actualBorderWidth", this.i.bf);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "raisedBackgroundColor", {
        /**
         * Gets or sets the color to use for the background of the button when the  type is raised.
        */
        get: function () {
            return brushToString(this.i.qv);
        },
        set: function (v) {
            this.i.qv = stringToBrush(v);
            this._a("raisedBackgroundColor", brushToString(this.i.qv));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "raisedDisabledBackgroundColor", {
        /**
         * Gets or sets the color to use for the disabled background of the button when the type is raised.
        */
        get: function () {
            return brushToString(this.i.qx);
        },
        set: function (v) {
            this.i.qx = stringToBrush(v);
            this._a("raisedDisabledBackgroundColor", brushToString(this.i.qx));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "raisedDisabledBorderColor", {
        /**
         * Gets or sets the color to use for the disabled border of the button when the type is raised.
        */
        get: function () {
            return brushToString(this.i.qy);
        },
        set: function (v) {
            this.i.qy = stringToBrush(v);
            this._a("raisedDisabledBorderColor", brushToString(this.i.qy));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "raisedDisabledTextColor", {
        /**
         * Gets or sets the color to use for the disabled text of the button when the type is raised.
        */
        get: function () {
            return brushToString(this.i.qz);
        },
        set: function (v) {
            this.i.qz = stringToBrush(v);
            this._a("raisedDisabledTextColor", brushToString(this.i.qz));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "raisedDisabledElevation", {
        /**
         * Gets or sets the disabled elevation to use for the button when the type is raised.
        */
        get: function () {
            return this.i.dy;
        },
        set: function (v) {
            this.i.dy = +v;
            this._a("raisedDisabledElevation", this.i.dy);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "raisedHoverBackgroundColor", {
        /**
         * Gets or sets the hover color to use for the background of the button when the  type is raised.
        */
        get: function () {
            return brushToString(this.i.q2);
        },
        set: function (v) {
            this.i.q2 = stringToBrush(v);
            this._a("raisedHoverBackgroundColor", brushToString(this.i.q2));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "raisedBorderColor", {
        /**
         * Gets or sets the border color to use for the button when the type is raised.
        */
        get: function () {
            return brushToString(this.i.qw);
        },
        set: function (v) {
            this.i.qw = stringToBrush(v);
            this._a("raisedBorderColor", brushToString(this.i.qw));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "raisedRestingElevation", {
        /**
         * Gets or sets the elevation to use for the button when the type is raised.
        */
        get: function () {
            return this.i.d1;
        },
        set: function (v) {
            this.i.d1 = +v;
            this._a("raisedRestingElevation", this.i.d1);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "raisedHoverElevation", {
        /**
         * Gets or sets the hover elevation to use for the button when the type is raised.
        */
        get: function () {
            return this.i.d0;
        },
        set: function (v) {
            this.i.d0 = +v;
            this._a("raisedHoverElevation", this.i.d0);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "raisedFocusElevation", {
        /**
         * Gets or sets the focus elevation to use for the button when the type is raised.
        */
        get: function () {
            return this.i.dz;
        },
        set: function (v) {
            this.i.dz = +v;
            this._a("raisedFocusElevation", this.i.dz);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "raisedBorderWidth", {
        /**
         * Gets or sets the width to use for the button border when the type is raised.
        */
        get: function () {
            return this.i.bw;
        },
        set: function (v) {
            this.i.bw = +v;
            this._a("raisedBorderWidth", this.i.bw);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "raisedCornerRadiusBottomRight", {
        get: function () {
            return this.i.k3 ? this.i.k3.b : NaN;
        },
        set: function (v) {
            this.ensureRaisedCornerRadius();
            this.i.k3.b = +v;
            this._a("raisedCornerRadiusBottomRight", this.i.k3.b);
            this.i.k3 = this.i.k3;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "raisedCornerRadiusBottomLeft", {
        get: function () {
            return this.i.k3 ? this.i.k3.a : NaN;
        },
        set: function (v) {
            this.ensureRaisedCornerRadius();
            this.i.k3.a = +v;
            this._a("raisedCornerRadiusBottomLeft", this.i.k3.a);
            this.i.k3 = this.i.k3;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "raisedCornerRadiusTopLeft", {
        get: function () {
            return this.i.k3 ? this.i.k3.c : NaN;
        },
        set: function (v) {
            this.ensureRaisedCornerRadius();
            this.i.k3.c = +v;
            this._a("raisedCornerRadiusTopLeft", this.i.k3.c);
            this.i.k3 = this.i.k3;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "raisedCornerRadiusTopRight", {
        get: function () {
            return this.i.k3 ? this.i.k3.d : NaN;
        },
        set: function (v) {
            this.ensureRaisedCornerRadius();
            this.i.k3.d = +v;
            this._a("raisedCornerRadiusTopRight", this.i.k3.d);
            this.i.k3 = this.i.k3;
        },
        enumerable: false,
        configurable: true
    });
    IgcXButtonComponent.prototype.ensureRaisedCornerRadius = function () {
        if (this.i.k3) {
            return;
        }
        this.i.k3 = new CornerRadius(2);
    };
    Object.defineProperty(IgcXButtonComponent.prototype, "raisedRippleColor", {
        /**
         * Gets or sets the color to use for the background when the button is pressed and the type is floating action button.
        */
        get: function () {
            return brushToString(this.i.q4);
        },
        set: function (v) {
            this.i.q4 = stringToBrush(v);
            this._a("raisedRippleColor", brushToString(this.i.q4));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "flatBackgroundColor", {
        /**
         * Gets or sets the color to use for the background of the button when the type is flat.
        */
        get: function () {
            return brushToString(this.i.pu);
        },
        set: function (v) {
            this.i.pu = stringToBrush(v);
            this._a("flatBackgroundColor", brushToString(this.i.pu));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "flatDisabledBackgroundColor", {
        /**
         * Gets or sets the color to use for the disabled background of the button when the type is flat.
        */
        get: function () {
            return brushToString(this.i.pw);
        },
        set: function (v) {
            this.i.pw = stringToBrush(v);
            this._a("flatDisabledBackgroundColor", brushToString(this.i.pw));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "flatDisabledBorderColor", {
        /**
         * Gets or sets the color to use for the disabled border of the button when the type is flat.
        */
        get: function () {
            return brushToString(this.i.px);
        },
        set: function (v) {
            this.i.px = stringToBrush(v);
            this._a("flatDisabledBorderColor", brushToString(this.i.px));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "flatDisabledTextColor", {
        /**
         * Gets or sets the color to use for the disabled text of the button when the type is flat.
        */
        get: function () {
            return brushToString(this.i.py);
        },
        set: function (v) {
            this.i.py = stringToBrush(v);
            this._a("flatDisabledTextColor", brushToString(this.i.py));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "flatDisabledElevation", {
        /**
         * Gets or sets the disabled elevation to use for the button when the type is flat.
        */
        get: function () {
            return this.i.dj;
        },
        set: function (v) {
            this.i.dj = +v;
            this._a("flatDisabledElevation", this.i.dj);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "flatHoverBackgroundColor", {
        /**
         * Gets or sets the hover color to use for the background of the button when the type is flat.
        */
        get: function () {
            return brushToString(this.i.p1);
        },
        set: function (v) {
            this.i.p1 = stringToBrush(v);
            this._a("flatHoverBackgroundColor", brushToString(this.i.p1));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "flatBorderColor", {
        /**
         * Gets or sets the border color to use for the button when the type is flat.
        */
        get: function () {
            return brushToString(this.i.pv);
        },
        set: function (v) {
            this.i.pv = stringToBrush(v);
            this._a("flatBorderColor", brushToString(this.i.pv));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "flatRestingElevation", {
        /**
         * Gets or sets the elevation to use for the button when the type is flat.
        */
        get: function () {
            return this.i.dm;
        },
        set: function (v) {
            this.i.dm = +v;
            this._a("flatRestingElevation", this.i.dm);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "flatHoverElevation", {
        /**
         * Gets or sets the hover elevation to use for the button when the type is flat.
        */
        get: function () {
            return this.i.dl;
        },
        set: function (v) {
            this.i.dl = +v;
            this._a("flatHoverElevation", this.i.dl);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "flatFocusElevation", {
        /**
         * Gets or sets the focus elevation to use for the button when the type is flat.
        */
        get: function () {
            return this.i.dk;
        },
        set: function (v) {
            this.i.dk = +v;
            this._a("flatFocusElevation", this.i.dk);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "flatRippleColor", {
        /**
         * Gets or sets the color to use for the background when the button is pressed and the type is floating action button.
        */
        get: function () {
            return brushToString(this.i.p3);
        },
        set: function (v) {
            this.i.p3 = stringToBrush(v);
            this._a("flatRippleColor", brushToString(this.i.p3));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "flatTextColor", {
        /**
         * Gets or sets the color to use for the text of the button when type is flat.
        */
        get: function () {
            return brushToString(this.i.p4);
        },
        set: function (v) {
            this.i.p4 = stringToBrush(v);
            this._a("flatTextColor", brushToString(this.i.p4));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "flatHoverTextColor", {
        /**
         * Gets or sets the color to use for the hovered text of the button when type is flat.
        */
        get: function () {
            return brushToString(this.i.p2);
        },
        set: function (v) {
            this.i.p2 = stringToBrush(v);
            this._a("flatHoverTextColor", brushToString(this.i.p2));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "flatFocusBackgroundColor", {
        /**
         * Gets or sets the color to use for the backround the button when it is focused and flat.
        */
        get: function () {
            return brushToString(this.i.pz);
        },
        set: function (v) {
            this.i.pz = stringToBrush(v);
            this._a("flatFocusBackgroundColor", brushToString(this.i.pz));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "flatFocusTextColor", {
        /**
         * Gets or sets the color to use for the text the button when it is focused and flat.
        */
        get: function () {
            return brushToString(this.i.p0);
        },
        set: function (v) {
            this.i.p0 = stringToBrush(v);
            this._a("flatFocusTextColor", brushToString(this.i.p0));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "flatBorderWidth", {
        /**
         * Gets or sets the width to use for the button border when the type is flat.
        */
        get: function () {
            return this.i.br;
        },
        set: function (v) {
            this.i.br = +v;
            this._a("flatBorderWidth", this.i.br);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "flatCornerRadiusBottomRight", {
        get: function () {
            return this.i.k0 ? this.i.k0.b : NaN;
        },
        set: function (v) {
            this.ensureFlatCornerRadius();
            this.i.k0.b = +v;
            this._a("flatCornerRadiusBottomRight", this.i.k0.b);
            this.i.k0 = this.i.k0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "flatCornerRadiusBottomLeft", {
        get: function () {
            return this.i.k0 ? this.i.k0.a : NaN;
        },
        set: function (v) {
            this.ensureFlatCornerRadius();
            this.i.k0.a = +v;
            this._a("flatCornerRadiusBottomLeft", this.i.k0.a);
            this.i.k0 = this.i.k0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "flatCornerRadiusTopLeft", {
        get: function () {
            return this.i.k0 ? this.i.k0.c : NaN;
        },
        set: function (v) {
            this.ensureFlatCornerRadius();
            this.i.k0.c = +v;
            this._a("flatCornerRadiusTopLeft", this.i.k0.c);
            this.i.k0 = this.i.k0;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "flatCornerRadiusTopRight", {
        get: function () {
            return this.i.k0 ? this.i.k0.d : NaN;
        },
        set: function (v) {
            this.ensureFlatCornerRadius();
            this.i.k0.d = +v;
            this._a("flatCornerRadiusTopRight", this.i.k0.d);
            this.i.k0 = this.i.k0;
        },
        enumerable: false,
        configurable: true
    });
    IgcXButtonComponent.prototype.ensureFlatCornerRadius = function () {
        if (this.i.k0) {
            return;
        }
        this.i.k0 = new CornerRadius(2);
    };
    Object.defineProperty(IgcXButtonComponent.prototype, "backgroundColor", {
        /**
         * Gets or sets the color to use for the background when the button regardless of type.
        */
        get: function () {
            return brushToString(this.i.ns);
        },
        set: function (v) {
            this.i.ns = stringToBrush(v);
            this._a("backgroundColor", brushToString(this.i.ns));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "disabledBackgroundColor", {
        /**
         * Gets or sets the color to use for the disabled background of the button when the type is disabled.
        */
        get: function () {
            return brushToString(this.i.pg);
        },
        set: function (v) {
            this.i.pg = stringToBrush(v);
            this._a("disabledBackgroundColor", brushToString(this.i.pg));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "disabledBorderColor", {
        /**
         * Gets or sets the color to use for the disabled border of the button when the type is raised.
        */
        get: function () {
            return brushToString(this.i.ph);
        },
        set: function (v) {
            this.i.ph = stringToBrush(v);
            this._a("disabledBorderColor", brushToString(this.i.ph));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "disabledTextColor", {
        /**
         * Gets or sets the color to use for the disabled text of the button when the type is raised.
        */
        get: function () {
            return brushToString(this.i.pi);
        },
        set: function (v) {
            this.i.pi = stringToBrush(v);
            this._a("disabledTextColor", brushToString(this.i.pi));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "disabledElevation", {
        /**
         * Gets or sets the disabled elevation to use for the button when the type is raised.
        */
        get: function () {
            return this.i.de;
        },
        set: function (v) {
            this.i.de = +v;
            this._a("disabledElevation", this.i.de);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "elevationMode", {
        /**
         * Gets or sets the disabled elevation to use for the button when the type is raised.
        */
        get: function () {
            return this.i.w;
        },
        set: function (v) {
            this.i.w = ensureEnum(ElevationMode_$type, v);
            this._a("elevationMode", enumToString(ElevationMode_$type, this.i.w));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "hoverBackgroundColor", {
        /**
         * Gets or sets the hover color to use for the background of the button when the  type is hovered.
        */
        get: function () {
            return brushToString(this.i.p7);
        },
        set: function (v) {
            this.i.p7 = stringToBrush(v);
            this._a("hoverBackgroundColor", brushToString(this.i.p7));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "borderColor", {
        /**
         * Gets or sets the border color to use for the button regardless of type.
        */
        get: function () {
            return brushToString(this.i.nt);
        },
        set: function (v) {
            this.i.nt = stringToBrush(v);
            this._a("borderColor", brushToString(this.i.nt));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "restingElevation", {
        /**
         * Gets or sets the elevation to use for the button regardless of type.
        */
        get: function () {
            return this.i.d2;
        },
        set: function (v) {
            this.i.d2 = +v;
            this._a("restingElevation", this.i.d2);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "hoverElevation", {
        /**
         * Gets or sets the hover elevation to use for the button regardless of type.
        */
        get: function () {
            return this.i.dp;
        },
        set: function (v) {
            this.i.dp = +v;
            this._a("hoverElevation", this.i.dp);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "focusElevation", {
        /**
         * Gets or sets the focus elevation to use for the button regardless of type.
        */
        get: function () {
            return this.i.dn;
        },
        set: function (v) {
            this.i.dn = +v;
            this._a("focusElevation", this.i.dn);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "textStyle", {
        /**
         * Gets or sets the use for the button.
        */
        get: function () {
            if (this.i.aa == null) {
                return null;
            }
            return this.i.aa.fontString;
        },
        set: function (v) {
            var fi = new FontInfo();
            fi.fontString = v;
            this.i.aa = fi;
            this._a("textStyle", this.i.aa != null ? this.i.aa.fontString : "");
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "textColor", {
        /**
         * Gets or sets the color to use for the text of the button regardless of type.
        */
        get: function () {
            return brushToString(this.i.q7);
        },
        set: function (v) {
            this.i.q7 = stringToBrush(v);
            this._a("textColor", brushToString(this.i.q7));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "hoverTextColor", {
        /**
         * Gets or sets the color to use for the hovered text of the button regardless of type.
        */
        get: function () {
            return brushToString(this.i.p8);
        },
        set: function (v) {
            this.i.p8 = stringToBrush(v);
            this._a("hoverTextColor", brushToString(this.i.p8));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "rippleColor", {
        /**
         * Gets or sets the color to use for the background of the button regardless of type.
        */
        get: function () {
            return brushToString(this.i.q6);
        },
        set: function (v) {
            this.i.q6 = stringToBrush(v);
            this._a("rippleColor", brushToString(this.i.q6));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "raisedTextColor", {
        /**
         * Gets or sets the color to use for the text of the button when type is raised.
        */
        get: function () {
            return brushToString(this.i.q5);
        },
        set: function (v) {
            this.i.q5 = stringToBrush(v);
            this._a("raisedTextColor", brushToString(this.i.q5));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "raisedHoverTextColor", {
        /**
         * Gets or sets the color to use for the hovered text of the button when type is raised.
        */
        get: function () {
            return brushToString(this.i.q3);
        },
        set: function (v) {
            this.i.q3 = stringToBrush(v);
            this._a("raisedHoverTextColor", brushToString(this.i.q3));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "raisedFocusBackgroundColor", {
        /**
         * Gets or sets the color to use for the backround the button when it is focused and raised.
        */
        get: function () {
            return brushToString(this.i.q0);
        },
        set: function (v) {
            this.i.q0 = stringToBrush(v);
            this._a("raisedFocusBackgroundColor", brushToString(this.i.q0));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "raisedFocusTextColor", {
        /**
         * Gets or sets the color to use for the text the button when it is focused and raised.
        */
        get: function () {
            return brushToString(this.i.q1);
        },
        set: function (v) {
            this.i.q1 = stringToBrush(v);
            this._a("raisedFocusTextColor", brushToString(this.i.q1));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "focusBackgroundColor", {
        /**
         * Gets or sets the color to use for the backround the button when it is focused.
        */
        get: function () {
            return brushToString(this.i.p5);
        },
        set: function (v) {
            this.i.p5 = stringToBrush(v);
            this._a("focusBackgroundColor", brushToString(this.i.p5));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "focusTextColor", {
        /**
         * Gets or sets the color to use for the text of the button when it is focused.
        */
        get: function () {
            return brushToString(this.i.p6);
        },
        set: function (v) {
            this.i.p6 = stringToBrush(v);
            this._a("focusTextColor", brushToString(this.i.p6));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "borderWidth", {
        /**
         * Gets or sets the width to use for the button border regardless of type.
        */
        get: function () {
            return this.i.bg;
        },
        set: function (v) {
            this.i.bg = +v;
            this._a("borderWidth", this.i.bg);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "cornerRadiusBottomRight", {
        get: function () {
            return this.i.kt ? this.i.kt.b : NaN;
        },
        set: function (v) {
            this.ensureCornerRadius();
            this.i.kt.b = +v;
            this._a("cornerRadiusBottomRight", this.i.kt.b);
            this.i.kt = this.i.kt;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "cornerRadiusBottomLeft", {
        get: function () {
            return this.i.kt ? this.i.kt.a : NaN;
        },
        set: function (v) {
            this.ensureCornerRadius();
            this.i.kt.a = +v;
            this._a("cornerRadiusBottomLeft", this.i.kt.a);
            this.i.kt = this.i.kt;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "cornerRadiusTopLeft", {
        get: function () {
            return this.i.kt ? this.i.kt.c : NaN;
        },
        set: function (v) {
            this.ensureCornerRadius();
            this.i.kt.c = +v;
            this._a("cornerRadiusTopLeft", this.i.kt.c);
            this.i.kt = this.i.kt;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "cornerRadiusTopRight", {
        get: function () {
            return this.i.kt ? this.i.kt.d : NaN;
        },
        set: function (v) {
            this.ensureCornerRadius();
            this.i.kt.d = +v;
            this._a("cornerRadiusTopRight", this.i.kt.d);
            this.i.kt = this.i.kt;
        },
        enumerable: false,
        configurable: true
    });
    IgcXButtonComponent.prototype.ensureCornerRadius = function () {
        if (this.i.kt) {
            return;
        }
        this.i.kt = new CornerRadius(2);
    };
    Object.defineProperty(IgcXButtonComponent.prototype, "outlinedBackgroundColor", {
        /**
         * Gets or sets the color to use for the background of the button when the  type is outlined.
        */
        get: function () {
            return brushToString(this.i.qk);
        },
        set: function (v) {
            this.i.qk = stringToBrush(v);
            this._a("outlinedBackgroundColor", brushToString(this.i.qk));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "outlinedDisabledBackgroundColor", {
        /**
         * Gets or sets the color to use for the disabled background of the button when the type is outlined.
        */
        get: function () {
            return brushToString(this.i.qm);
        },
        set: function (v) {
            this.i.qm = stringToBrush(v);
            this._a("outlinedDisabledBackgroundColor", brushToString(this.i.qm));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "outlinedDisabledBorderColor", {
        /**
         * Gets or sets the color to use for the disabled border of the button when the type is outlined.
        */
        get: function () {
            return brushToString(this.i.qn);
        },
        set: function (v) {
            this.i.qn = stringToBrush(v);
            this._a("outlinedDisabledBorderColor", brushToString(this.i.qn));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "outlinedDisabledTextColor", {
        /**
         * Gets or sets the color to use for the disabled text of the button when the type is outlined.
        */
        get: function () {
            return brushToString(this.i.qo);
        },
        set: function (v) {
            this.i.qo = stringToBrush(v);
            this._a("outlinedDisabledTextColor", brushToString(this.i.qo));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "outlinedDisabledElevation", {
        /**
         * Gets or sets the disabled elevation to use for the button when the type is outlined.
        */
        get: function () {
            return this.i.du;
        },
        set: function (v) {
            this.i.du = +v;
            this._a("outlinedDisabledElevation", this.i.du);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "outlinedHoverBackgroundColor", {
        /**
         * Gets or sets the hover color to use for the background of the button when the  type is hoveredOutlined.
        */
        get: function () {
            return brushToString(this.i.qr);
        },
        set: function (v) {
            this.i.qr = stringToBrush(v);
            this._a("outlinedHoverBackgroundColor", brushToString(this.i.qr));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "outlinedBorderColor", {
        /**
         * Gets or sets the border color to use for the button when the type is outlined.
        */
        get: function () {
            return brushToString(this.i.ql);
        },
        set: function (v) {
            this.i.ql = stringToBrush(v);
            this._a("outlinedBorderColor", brushToString(this.i.ql));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "outlinedRestingElevation", {
        /**
         * Gets or sets the elevation to use for the button when the type is outlined.
        */
        get: function () {
            return this.i.dx;
        },
        set: function (v) {
            this.i.dx = +v;
            this._a("outlinedRestingElevation", this.i.dx);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "outlinedHoverElevation", {
        /**
         * Gets or sets the hover elevation to use for the button when the type is outlined.
        */
        get: function () {
            return this.i.dw;
        },
        set: function (v) {
            this.i.dw = +v;
            this._a("outlinedHoverElevation", this.i.dw);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "outlinedFocusElevation", {
        /**
         * Gets or sets the focus elevation to use for the button when the type is outlined.
        */
        get: function () {
            return this.i.dv;
        },
        set: function (v) {
            this.i.dv = +v;
            this._a("outlinedFocusElevation", this.i.dv);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "outlinedBorderWidth", {
        /**
         * Gets or sets the width to use for the button border when the type is outlined.
        */
        get: function () {
            return this.i.bv;
        },
        set: function (v) {
            this.i.bv = +v;
            this._a("outlinedBorderWidth", this.i.bv);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "outlinedCornerRadiusBottomRight", {
        get: function () {
            return this.i.k2 ? this.i.k2.b : NaN;
        },
        set: function (v) {
            this.ensureOutlinedCornerRadius();
            this.i.k2.b = +v;
            this._a("outlinedCornerRadiusBottomRight", this.i.k2.b);
            this.i.k2 = this.i.k2;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "outlinedCornerRadiusBottomLeft", {
        get: function () {
            return this.i.k2 ? this.i.k2.a : NaN;
        },
        set: function (v) {
            this.ensureOutlinedCornerRadius();
            this.i.k2.a = +v;
            this._a("outlinedCornerRadiusBottomLeft", this.i.k2.a);
            this.i.k2 = this.i.k2;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "outlinedCornerRadiusTopLeft", {
        get: function () {
            return this.i.k2 ? this.i.k2.c : NaN;
        },
        set: function (v) {
            this.ensureOutlinedCornerRadius();
            this.i.k2.c = +v;
            this._a("outlinedCornerRadiusTopLeft", this.i.k2.c);
            this.i.k2 = this.i.k2;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "outlinedCornerRadiusTopRight", {
        get: function () {
            return this.i.k2 ? this.i.k2.d : NaN;
        },
        set: function (v) {
            this.ensureOutlinedCornerRadius();
            this.i.k2.d = +v;
            this._a("outlinedCornerRadiusTopRight", this.i.k2.d);
            this.i.k2 = this.i.k2;
        },
        enumerable: false,
        configurable: true
    });
    IgcXButtonComponent.prototype.ensureOutlinedCornerRadius = function () {
        if (this.i.k2) {
            return;
        }
        this.i.k2 = new CornerRadius(2);
    };
    Object.defineProperty(IgcXButtonComponent.prototype, "outlinedRippleColor", {
        /**
         * Gets or sets the color to use for the background when the button is pressed and the type is floating action button.
        */
        get: function () {
            return brushToString(this.i.qt);
        },
        set: function (v) {
            this.i.qt = stringToBrush(v);
            this._a("outlinedRippleColor", brushToString(this.i.qt));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "outlinedTextColor", {
        /**
         * Gets or sets the color to use for the text of the button when type is outlined.
        */
        get: function () {
            return brushToString(this.i.qu);
        },
        set: function (v) {
            this.i.qu = stringToBrush(v);
            this._a("outlinedTextColor", brushToString(this.i.qu));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "outlinedHoverTextColor", {
        /**
         * Gets or sets the color to use for the hovered text of the button when type is outlined.
        */
        get: function () {
            return brushToString(this.i.qs);
        },
        set: function (v) {
            this.i.qs = stringToBrush(v);
            this._a("outlinedHoverTextColor", brushToString(this.i.qs));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "outlinedFocusBackgroundColor", {
        /**
         * Gets or sets the color to use for the backround the button when it is focused and outlined.
        */
        get: function () {
            return brushToString(this.i.qp);
        },
        set: function (v) {
            this.i.qp = stringToBrush(v);
            this._a("outlinedFocusBackgroundColor", brushToString(this.i.qp));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "outlinedFocusTextColor", {
        /**
         * Gets or sets the color to use for the text the button when it is focused and outlined.
        */
        get: function () {
            return brushToString(this.i.qq);
        },
        set: function (v) {
            this.i.qq = stringToBrush(v);
            this._a("outlinedFocusTextColor", brushToString(this.i.qq));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "fabBackgroundColor", {
        /**
         * Gets or sets the color to use for the background of the button when the  type is floating action button.
        */
        get: function () {
            return brushToString(this.i.pj);
        },
        set: function (v) {
            this.i.pj = stringToBrush(v);
            this._a("fabBackgroundColor", brushToString(this.i.pj));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "fabDisabledBackgroundColor", {
        /**
         * Gets or sets the color to use for the disabled background of the button when the type is fab.
        */
        get: function () {
            return brushToString(this.i.pl);
        },
        set: function (v) {
            this.i.pl = stringToBrush(v);
            this._a("fabDisabledBackgroundColor", brushToString(this.i.pl));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "fabDisabledBorderColor", {
        /**
         * Gets or sets the color to use for the disabled border of the button when the type is fab.
        */
        get: function () {
            return brushToString(this.i.pm);
        },
        set: function (v) {
            this.i.pm = stringToBrush(v);
            this._a("fabDisabledBorderColor", brushToString(this.i.pm));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "fabDisabledTextColor", {
        /**
         * Gets or sets the color to use for the disabled text of the button when the type is fab.
        */
        get: function () {
            return brushToString(this.i.pn);
        },
        set: function (v) {
            this.i.pn = stringToBrush(v);
            this._a("fabDisabledTextColor", brushToString(this.i.pn));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "fabDisabledElevation", {
        /**
         * Gets or sets the disabled elevation to use for the button when the type is fab.
        */
        get: function () {
            return this.i.df;
        },
        set: function (v) {
            this.i.df = +v;
            this._a("fabDisabledElevation", this.i.df);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "fabHoverBackgroundColor", {
        /**
         * Gets or sets the hover color to use for the background of the button when the  type is hoveredFab.
        */
        get: function () {
            return brushToString(this.i.pq);
        },
        set: function (v) {
            this.i.pq = stringToBrush(v);
            this._a("fabHoverBackgroundColor", brushToString(this.i.pq));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "fabBorderColor", {
        /**
         * Gets or sets the border color to use for the button when the type is floating action button.
        */
        get: function () {
            return brushToString(this.i.pk);
        },
        set: function (v) {
            this.i.pk = stringToBrush(v);
            this._a("fabBorderColor", brushToString(this.i.pk));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "fabRestingElevation", {
        /**
         * Gets or sets the elevation to use for the button when the type is floating action button.
        */
        get: function () {
            return this.i.di;
        },
        set: function (v) {
            this.i.di = +v;
            this._a("fabRestingElevation", this.i.di);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "fabHoverElevation", {
        /**
         * Gets or sets the hover elevation to use for the button when the type is floating action button.
        */
        get: function () {
            return this.i.dh;
        },
        set: function (v) {
            this.i.dh = +v;
            this._a("fabHoverElevation", this.i.dh);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "fabFocusElevation", {
        /**
         * Gets or sets the focus elevation to use for the button when the type is floating action button.
        */
        get: function () {
            return this.i.dg;
        },
        set: function (v) {
            this.i.dg = +v;
            this._a("fabFocusElevation", this.i.dg);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "fabBorderWidth", {
        /**
         * Gets or sets the width to use for the button border when the type is floating action button.
        */
        get: function () {
            return this.i.bq;
        },
        set: function (v) {
            this.i.bq = +v;
            this._a("fabBorderWidth", this.i.bq);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "fabCornerRadiusBottomRight", {
        get: function () {
            return this.i.kz ? this.i.kz.b : NaN;
        },
        set: function (v) {
            this.ensureFabCornerRadius();
            this.i.kz.b = +v;
            this._a("fabCornerRadiusBottomRight", this.i.kz.b);
            this.i.kz = this.i.kz;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "fabCornerRadiusBottomLeft", {
        get: function () {
            return this.i.kz ? this.i.kz.a : NaN;
        },
        set: function (v) {
            this.ensureFabCornerRadius();
            this.i.kz.a = +v;
            this._a("fabCornerRadiusBottomLeft", this.i.kz.a);
            this.i.kz = this.i.kz;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "fabCornerRadiusTopLeft", {
        get: function () {
            return this.i.kz ? this.i.kz.c : NaN;
        },
        set: function (v) {
            this.ensureFabCornerRadius();
            this.i.kz.c = +v;
            this._a("fabCornerRadiusTopLeft", this.i.kz.c);
            this.i.kz = this.i.kz;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "fabCornerRadiusTopRight", {
        get: function () {
            return this.i.kz ? this.i.kz.d : NaN;
        },
        set: function (v) {
            this.ensureFabCornerRadius();
            this.i.kz.d = +v;
            this._a("fabCornerRadiusTopRight", this.i.kz.d);
            this.i.kz = this.i.kz;
        },
        enumerable: false,
        configurable: true
    });
    IgcXButtonComponent.prototype.ensureFabCornerRadius = function () {
        if (this.i.kz) {
            return;
        }
        this.i.kz = new CornerRadius(2);
    };
    Object.defineProperty(IgcXButtonComponent.prototype, "fabRippleColor", {
        /**
         * Gets or sets the color to use for the background when the button is pressed and the type is floating action button.
        */
        get: function () {
            return brushToString(this.i.ps);
        },
        set: function (v) {
            this.i.ps = stringToBrush(v);
            this._a("fabRippleColor", brushToString(this.i.ps));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "fabTextColor", {
        /**
         * Gets or sets the color to use for the text of the button when type is floating action button.
        */
        get: function () {
            return brushToString(this.i.pt);
        },
        set: function (v) {
            this.i.pt = stringToBrush(v);
            this._a("fabTextColor", brushToString(this.i.pt));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "fabHoverTextColor", {
        /**
         * Gets or sets the color to use for the hovered text of the button when type is floating action button.
        */
        get: function () {
            return brushToString(this.i.pr);
        },
        set: function (v) {
            this.i.pr = stringToBrush(v);
            this._a("fabHoverTextColor", brushToString(this.i.pr));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "fabFocusBackgroundColor", {
        /**
         * Gets or sets the color to use for the backround the button when it is focused and fab.
        */
        get: function () {
            return brushToString(this.i.po);
        },
        set: function (v) {
            this.i.po = stringToBrush(v);
            this._a("fabFocusBackgroundColor", brushToString(this.i.po));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "fabFocusTextColor", {
        /**
         * Gets or sets the color to use for the text the button when it is focused and fab.
        */
        get: function () {
            return brushToString(this.i.pp);
        },
        set: function (v) {
            this.i.pp = stringToBrush(v);
            this._a("fabFocusTextColor", brushToString(this.i.pp));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "iconBackgroundColor", {
        /**
         * Gets or sets the color to use for the background of the button when the  type is icon.
        */
        get: function () {
            return brushToString(this.i.p9);
        },
        set: function (v) {
            this.i.p9 = stringToBrush(v);
            this._a("iconBackgroundColor", brushToString(this.i.p9));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "iconDisabledBackgroundColor", {
        /**
         * Gets or sets the color to use for the disabled background of the button when the type is icon.
        */
        get: function () {
            return brushToString(this.i.qb);
        },
        set: function (v) {
            this.i.qb = stringToBrush(v);
            this._a("iconDisabledBackgroundColor", brushToString(this.i.qb));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "iconDisabledBorderColor", {
        /**
         * Gets or sets the color to use for the disabled border of the button when the type is icon.
        */
        get: function () {
            return brushToString(this.i.qc);
        },
        set: function (v) {
            this.i.qc = stringToBrush(v);
            this._a("iconDisabledBorderColor", brushToString(this.i.qc));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "iconDisabledTextColor", {
        /**
         * Gets or sets the color to use for the disabled text of the button when the type is icon.
        */
        get: function () {
            return brushToString(this.i.qd);
        },
        set: function (v) {
            this.i.qd = stringToBrush(v);
            this._a("iconDisabledTextColor", brushToString(this.i.qd));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "iconDisabledElevation", {
        /**
         * Gets or sets the disabled elevation to use for the button when the type is icon.
        */
        get: function () {
            return this.i.dq;
        },
        set: function (v) {
            this.i.dq = +v;
            this._a("iconDisabledElevation", this.i.dq);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "iconHoverBackgroundColor", {
        /**
         * Gets or sets the hover color to use for the background of the button when the  type is hoveredIcon.
        */
        get: function () {
            return brushToString(this.i.qg);
        },
        set: function (v) {
            this.i.qg = stringToBrush(v);
            this._a("iconHoverBackgroundColor", brushToString(this.i.qg));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "iconBorderColor", {
        /**
         * Gets or sets the border color to use for the button when the type is icon.
        */
        get: function () {
            return brushToString(this.i.qa);
        },
        set: function (v) {
            this.i.qa = stringToBrush(v);
            this._a("iconBorderColor", brushToString(this.i.qa));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "iconRestingElevation", {
        /**
         * Gets or sets the elevation to use for the button when the type is icon.
        */
        get: function () {
            return this.i.dt;
        },
        set: function (v) {
            this.i.dt = +v;
            this._a("iconRestingElevation", this.i.dt);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "iconHoverElevation", {
        /**
         * Gets or sets the hover elevation to use for the button when the type is icon.
        */
        get: function () {
            return this.i.ds;
        },
        set: function (v) {
            this.i.ds = +v;
            this._a("iconHoverElevation", this.i.ds);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "iconFocusElevation", {
        /**
         * Gets or sets the focus elevation to use for the button when the type is icon.
        */
        get: function () {
            return this.i.dr;
        },
        set: function (v) {
            this.i.dr = +v;
            this._a("iconFocusElevation", this.i.dr);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "iconBorderWidth", {
        /**
         * Gets or sets the width to use for the button border when the type is icon.
        */
        get: function () {
            return this.i.bs;
        },
        set: function (v) {
            this.i.bs = +v;
            this._a("iconBorderWidth", this.i.bs);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "iconCornerRadiusBottomRight", {
        get: function () {
            return this.i.k1 ? this.i.k1.b : NaN;
        },
        set: function (v) {
            this.ensureIconCornerRadius();
            this.i.k1.b = +v;
            this._a("iconCornerRadiusBottomRight", this.i.k1.b);
            this.i.k1 = this.i.k1;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "iconCornerRadiusBottomLeft", {
        get: function () {
            return this.i.k1 ? this.i.k1.a : NaN;
        },
        set: function (v) {
            this.ensureIconCornerRadius();
            this.i.k1.a = +v;
            this._a("iconCornerRadiusBottomLeft", this.i.k1.a);
            this.i.k1 = this.i.k1;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "iconCornerRadiusTopLeft", {
        get: function () {
            return this.i.k1 ? this.i.k1.c : NaN;
        },
        set: function (v) {
            this.ensureIconCornerRadius();
            this.i.k1.c = +v;
            this._a("iconCornerRadiusTopLeft", this.i.k1.c);
            this.i.k1 = this.i.k1;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "iconCornerRadiusTopRight", {
        get: function () {
            return this.i.k1 ? this.i.k1.d : NaN;
        },
        set: function (v) {
            this.ensureIconCornerRadius();
            this.i.k1.d = +v;
            this._a("iconCornerRadiusTopRight", this.i.k1.d);
            this.i.k1 = this.i.k1;
        },
        enumerable: false,
        configurable: true
    });
    IgcXButtonComponent.prototype.ensureIconCornerRadius = function () {
        if (this.i.k1) {
            return;
        }
        this.i.k1 = new CornerRadius(2);
    };
    Object.defineProperty(IgcXButtonComponent.prototype, "iconRippleColor", {
        /**
         * Gets or sets the color to use for the background when the button is pressed and the type is floating action button.
        */
        get: function () {
            return brushToString(this.i.qi);
        },
        set: function (v) {
            this.i.qi = stringToBrush(v);
            this._a("iconRippleColor", brushToString(this.i.qi));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "iconTextColor", {
        /**
         * Gets or sets the color to use for the text of the button when type is icon.
        */
        get: function () {
            return brushToString(this.i.qj);
        },
        set: function (v) {
            this.i.qj = stringToBrush(v);
            this._a("iconTextColor", brushToString(this.i.qj));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "iconHoverTextColor", {
        /**
         * Gets or sets the color to use for the hovered text of the button when type is icon.
        */
        get: function () {
            return brushToString(this.i.qh);
        },
        set: function (v) {
            this.i.qh = stringToBrush(v);
            this._a("iconHoverTextColor", brushToString(this.i.qh));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "iconFocusBackgroundColor", {
        /**
         * Gets or sets the color to use for the backround the button when it is focused and icon.
        */
        get: function () {
            return brushToString(this.i.qe);
        },
        set: function (v) {
            this.i.qe = stringToBrush(v);
            this._a("iconFocusBackgroundColor", brushToString(this.i.qe));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "iconFocusTextColor", {
        /**
         * Gets or sets the color to use for the text the button when it is focused and icon.
        */
        get: function () {
            return brushToString(this.i.qf);
        },
        set: function (v) {
            this.i.qf = stringToBrush(v);
            this._a("iconFocusTextColor", brushToString(this.i.qf));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "inputId", {
        /**
         * Gets or sets the id to use for the internal native checkbox.
        */
        get: function () {
            return this.i.hu;
        },
        set: function (v) {
            this.i.hu = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "id", {
        /**
         * Gets or sets the id to use for the checkbox.
        */
        get: function () {
            return this.i.hs;
        },
        set: function (v) {
            this.i.hs = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "display", {
        /**
         * Gets or sets the id to use for the checkbox.
        */
        get: function () {
            return this.i.fw;
        },
        set: function (v) {
            this.i.fw = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "flexDirection", {
        /**
         * Gets or sets the id to use for the checkbox.
        */
        get: function () {
            return this.i.g0;
        },
        set: function (v) {
            this.i.g0 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "flexGrow", {
        /**
         * Gets or sets the flex-grow setting for the button.
        */
        get: function () {
            return this.i.g2;
        },
        set: function (v) {
            this.i.g2 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "alignItems", {
        /**
         * Gets or sets the id to use for the checkbox.
        */
        get: function () {
            return this.i.e7;
        },
        set: function (v) {
            this.i.e7 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "value", {
        /**
         * Gets or sets value to use for the checkbox.
        */
        get: function () {
            return this.i.ea;
        },
        set: function (v) {
            this.i.ea = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "name", {
        /**
         * Gets or sets name to use for the button.
        */
        get: function () {
            return this.i.h2;
        },
        set: function (v) {
            this.i.h2 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "tabIndex", {
        /**
         * Gets or sets TabIndex to use for the checkbox.
        */
        get: function () {
            return this.i.d3;
        },
        set: function (v) {
            this.i.d3 = +v;
            this._a("tabIndex", this.i.d3);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "ariaLabel", {
        /**
         * Gets or sets the value of the aria-label attribute.
        */
        get: function () {
            return this.i.e9;
        },
        set: function (v) {
            this.i.e9 = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "fillAvailableSpace", {
        /**
         * Gets or sets whether the button should fill the available space. If false, the button
         * will use an intrinsic size.
        */
        get: function () {
            return this.i.av;
        },
        set: function (v) {
            this.i.av = ensureBool(v);
            this._a("fillAvailableSpace", this.i.av);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "focused", {
        /**
         * Gets or sets if the checkbox is Focused.
        */
        get: function () {
            return this.i.focused;
        },
        set: function (v) {
            this.i.focused = ensureBool(v);
            this._a("focused", this.i.focused);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "isFocusStyleEnabled", {
        /**
         * Gets or sets if the button show use styling to show focus.
        */
        get: function () {
            return this.i.az;
        },
        set: function (v) {
            this.i.az = ensureBool(v);
            this._a("isFocusStyleEnabled", this.i.az);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "disableRipple", {
        /**
         * Gets or sets whether to disable the ripple effect for the button.
        */
        get: function () {
            return this.i.at;
        },
        set: function (v) {
            this.i.at = ensureBool(v);
            this._a("disableRipple", this.i.at);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "actualDisableRipple", {
        /**
         * Gets whether to actually disable the ripple effect for the button.
        */
        get: function () {
            return this.i.ap;
        },
        set: function (v) {
            this.i.ap = ensureBool(v);
            this._a("actualDisableRipple", this.i.ap);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "disableHover", {
        /**
         * Gets or sets whether the hover effect is disabled.
        */
        get: function () {
            return this.i.ar;
        },
        set: function (v) {
            this.i.ar = ensureBool(v);
            this._a("disableHover", this.i.ar);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "isHover", {
        /**
         * Gets or sets whether the checkbox is checked.
        */
        get: function () {
            return this.i.a0;
        },
        set: function (v) {
            this.i.a0 = ensureBool(v);
            this._a("isHover", this.i.a0);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "disabled", {
        /**
         * Gets or sets whether the checkbox is disabled.
        */
        get: function () {
            return this.i.disabled;
        },
        set: function (v) {
            this.i.disabled = ensureBool(v);
            this._a("disabled", this.i.disabled);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "disableTransitions", {
        /**
         * Gets or sets whether the checkbox transitions are disabled.
        */
        get: function () {
            return this.i.au;
        },
        set: function (v) {
            this.i.au = ensureBool(v);
            this._a("disableTransitions", this.i.au);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "disablePointer", {
        /**
         * Gets or sets whether the cursor will change into a pointer when the button is hovered.
        */
        get: function () {
            return this.i.as;
        },
        set: function (v) {
            this.i.as = ensureBool(v);
            this._a("disablePointer", this.i.as);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "contentPaddingLeft", {
        /**
         * Gets or sets the left padding for the button content.
        */
        get: function () {
            return this.i.bi;
        },
        set: function (v) {
            this.i.bi = +v;
            this._a("contentPaddingLeft", this.i.bi);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "contentPaddingTop", {
        /**
         * Gets or sets the top padding for the button content.
        */
        get: function () {
            return this.i.bk;
        },
        set: function (v) {
            this.i.bk = +v;
            this._a("contentPaddingTop", this.i.bk);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "contentPaddingRight", {
        /**
         * Gets or sets the right padding for the button content.
        */
        get: function () {
            return this.i.bj;
        },
        set: function (v) {
            this.i.bj = +v;
            this._a("contentPaddingRight", this.i.bj);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "contentPaddingBottom", {
        /**
         * Gets or sets the bottom padding for the button content.
        */
        get: function () {
            return this.i.bh;
        },
        set: function (v) {
            this.i.bh = +v;
            this._a("contentPaddingBottom", this.i.bh);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "horizontalContentAlignment", {
        get: function () {
            return this.i.k5;
        },
        set: function (v) {
            this.i.k5 = ensureEnum(HorizontalAlignment_$type, v);
            this._a("horizontalContentAlignment", enumToString(HorizontalAlignment_$type, this.i.k5));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "verticalContentAlignment", {
        get: function () {
            return this.i.q9;
        },
        set: function (v) {
            this.i.q9 = ensureEnum(VerticalAlignment_$type, v);
            this._a("verticalContentAlignment", enumToString(VerticalAlignment_$type, this.i.q9));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "clickTunneling", {
        /**
         * Gets or sets if clicking on the button is allowed to tunnel down to button content.
        */
        get: function () {
            return this.i.aq;
        },
        set: function (v) {
            this.i.aq = ensureBool(v);
            this._a("clickTunneling", this.i.aq);
        },
        enumerable: false,
        configurable: true
    });
    IgcXButtonComponent.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    Object.defineProperty(IgcXButtonComponent.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: false,
        configurable: true
    });
    IgcXButtonComponent.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgcXButtonComponent.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("XButtonComponent");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    IgcXButtonComponent.prototype.onDetachedFromUI = function () {
        this.i.onDetachedFromUI();
    };
    IgcXButtonComponent.prototype.onAttachedToUI = function () {
        this.i.onAttachedToUI();
    };
    /**
     * Exports visual information about the current state of the grid.
    
    */
    IgcXButtonComponent.prototype.exportVisualModel = function () {
        var iv = this.i.d7();
        return (iv);
    };
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    IgcXButtonComponent.prototype.exportSerializedVisualModel = function () {
        var iv = this.i.f0();
        return (iv);
    };
    Object.defineProperty(IgcXButtonComponent.prototype, "clicked", {
        get: function () {
            return this._clicked;
        },
        set: function (ev) {
            var _this = this;
            if (this._clicked_wrapped !== null) {
                this.i.clicked = delegateRemove(this.i.clicked, this._clicked_wrapped);
                this._clicked_wrapped = null;
                this._clicked = null;
            }
            this._clicked = ev;
            this._clicked_wrapped = function (o, e) {
                var outerArgs = new IgcButtonClickEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeClicked) {
                    _this.beforeClicked(_this, outerArgs);
                }
                if (_this._clicked) {
                    _this._clicked(_this, outerArgs);
                }
            };
            this.i.clicked = delegateCombine(this.i.clicked, this._clicked_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "gotFocus", {
        get: function () {
            return this._gotFocus;
        },
        set: function (ev) {
            var _this = this;
            if (this._gotFocus_wrapped !== null) {
                this.i.gotFocus = delegateRemove(this.i.gotFocus, this._gotFocus_wrapped);
                this._gotFocus_wrapped = null;
                this._gotFocus = null;
            }
            this._gotFocus = ev;
            this._gotFocus_wrapped = function (o, e) {
                var outerArgs = new IgcFocusEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeGotFocus) {
                    _this.beforeGotFocus(_this, outerArgs);
                }
                if (_this._gotFocus) {
                    _this._gotFocus(_this, outerArgs);
                }
            };
            this.i.gotFocus = delegateCombine(this.i.gotFocus, this._gotFocus_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcXButtonComponent.prototype, "lostFocus", {
        get: function () {
            return this._lostFocus;
        },
        set: function (ev) {
            var _this = this;
            if (this._lostFocus_wrapped !== null) {
                this.i.lostFocus = delegateRemove(this.i.lostFocus, this._lostFocus_wrapped);
                this._lostFocus_wrapped = null;
                this._lostFocus = null;
            }
            this._lostFocus = ev;
            this._lostFocus_wrapped = function (o, e) {
                var outerArgs = new IgcFocusEventArgs();
                outerArgs._provideImplementation(e);
                if (_this.beforeLostFocus) {
                    _this.beforeLostFocus(_this, outerArgs);
                }
                if (_this._lostFocus) {
                    _this._lostFocus(_this, outerArgs);
                }
            };
            this.i.lostFocus = delegateCombine(this.i.lostFocus, this._lostFocus_wrapped);
            ;
        },
        enumerable: false,
        configurable: true
    });
    IgcXButtonComponent._observedAttributesIgcXButtonComponent = null;
    IgcXButtonComponent.htmlTagName = "igc-x-button";
    IgcXButtonComponent._isElementRegistered = false;
    return IgcXButtonComponent;
}(IgcHTMLElement));
export { IgcXButtonComponent };
